/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;
    if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;



/* Line 268 of yacc.c  */
#line 547 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIRM = 302,
     UNDO = 303,
     CHECK = 304,
     TIMEOUT = 305,
     CONFIGURE = 306,
     DOWN = 307,
     KERNEL = 308,
     PERSIST = 309,
     SCAN = 310,
     TIME = 311,
     LEARN = 312,
     DEVICE = 313,
     ROUTES = 314,
     KRT_SOURCE = 315,
     KRT_METRIC = 316,
     ASYNC = 317,
     TABLE = 318,
     KRT_PREFSRC = 319,
     KRT_REALM = 320,
     ROUTER = 321,
     ID = 322,
     PROTOCOL = 323,
     TEMPLATE = 324,
     PREFERENCE = 325,
     DISABLED = 326,
     DIRECT = 327,
     INTERFACE = 328,
     IMPORT = 329,
     EXPORT = 330,
     FILTER = 331,
     NONE = 332,
     STATES = 333,
     FILTERS = 334,
     RECEIVE = 335,
     LIMIT = 336,
     ACTION = 337,
     WARN = 338,
     BLOCK = 339,
     RESTART = 340,
     DISABLE = 341,
     KEEP = 342,
     FILTERED = 343,
     PASSWORD = 344,
     FROM = 345,
     PASSIVE = 346,
     TO = 347,
     EVENTS = 348,
     PACKETS = 349,
     PROTOCOLS = 350,
     INTERFACES = 351,
     PRIMARY = 352,
     STATS = 353,
     COUNT = 354,
     FOR = 355,
     COMMANDS = 356,
     PREEXPORT = 357,
     GENERATE = 358,
     ROA = 359,
     MAX = 360,
     FLUSH = 361,
     LISTEN = 362,
     BGP = 363,
     V6ONLY = 364,
     DUAL = 365,
     ADDRESS = 366,
     PORT = 367,
     PASSWORDS = 368,
     DESCRIPTION = 369,
     SORTED = 370,
     RELOAD = 371,
     IN = 372,
     OUT = 373,
     MRTDUMP = 374,
     MESSAGES = 375,
     RESTRICT = 376,
     MEMORY = 377,
     IGP_METRIC = 378,
     SHOW = 379,
     STATUS = 380,
     SUMMARY = 381,
     ROUTE = 382,
     SYMBOLS = 383,
     ADD = 384,
     DELETE = 385,
     DUMP = 386,
     RESOURCES = 387,
     SOCKETS = 388,
     NEIGHBORS = 389,
     ATTRIBUTES = 390,
     ECHO = 391,
     ENABLE = 392,
     FUNCTION = 393,
     PRINT = 394,
     PRINTN = 395,
     UNSET = 396,
     RETURN = 397,
     ACCEPT = 398,
     REJECT = 399,
     QUITBIRD = 400,
     INT = 401,
     BOOL = 402,
     IP = 403,
     PREFIX = 404,
     PAIR = 405,
     QUAD = 406,
     EC = 407,
     SET = 408,
     STRING = 409,
     BGPMASK = 410,
     BGPPATH = 411,
     CLIST = 412,
     ECLIST = 413,
     IF = 414,
     THEN = 415,
     ELSE = 416,
     CASE = 417,
     TRUE = 418,
     FALSE = 419,
     RT = 420,
     RO = 421,
     UNKNOWN = 422,
     GENERIC = 423,
     GW = 424,
     NET = 425,
     MASK = 426,
     PROTO = 427,
     SOURCE = 428,
     SCOPE = 429,
     CAST = 430,
     DEST = 431,
     LEN = 432,
     DEFINED = 433,
     CONTAINS = 434,
     RESET = 435,
     PREPEND = 436,
     FIRST = 437,
     LAST = 438,
     MATCH = 439,
     ROA_CHECK = 440,
     EMPTY = 441,
     WHERE = 442,
     EVAL = 443,
     LOCAL = 444,
     NEIGHBOR = 445,
     AS = 446,
     HOLD = 447,
     CONNECT = 448,
     RETRY = 449,
     KEEPALIVE = 450,
     MULTIHOP = 451,
     STARTUP = 452,
     VIA = 453,
     NEXT = 454,
     HOP = 455,
     SELF = 456,
     DEFAULT = 457,
     PATH = 458,
     METRIC = 459,
     START = 460,
     DELAY = 461,
     FORGET = 462,
     WAIT = 463,
     AFTER = 464,
     BGP_PATH = 465,
     BGP_LOCAL_PREF = 466,
     BGP_MED = 467,
     BGP_ORIGIN = 468,
     BGP_NEXT_HOP = 469,
     BGP_ATOMIC_AGGR = 470,
     BGP_AGGREGATOR = 471,
     BGP_COMMUNITY = 472,
     BGP_EXT_COMMUNITY = 473,
     RR = 474,
     RS = 475,
     CLIENT = 476,
     CLUSTER = 477,
     AS4 = 478,
     ADVERTISE = 479,
     IPV4 = 480,
     CAPABILITIES = 481,
     PREFER = 482,
     OLDER = 483,
     MISSING = 484,
     LLADDR = 485,
     DROP = 486,
     IGNORE = 487,
     REFRESH = 488,
     INTERPRET = 489,
     COMMUNITIES = 490,
     BGP_ORIGINATOR_ID = 491,
     BGP_CLUSTER_LIST = 492,
     IGP = 493,
     GATEWAY = 494,
     RECURSIVE = 495,
     MED = 496,
     TTL = 497,
     SECURITY = 498,
     DETERMINISTIC = 499,
     SECONDARY = 500,
     OSPF = 501,
     AREA = 502,
     OSPF_METRIC1 = 503,
     OSPF_METRIC2 = 504,
     OSPF_TAG = 505,
     OSPF_ROUTER_ID = 506,
     RFC1583COMPAT = 507,
     STUB = 508,
     TICK = 509,
     COST = 510,
     COST2 = 511,
     RETRANSMIT = 512,
     HELLO = 513,
     TRANSMIT = 514,
     PRIORITY = 515,
     DEAD = 516,
     TYPE = 517,
     BROADCAST = 518,
     BCAST = 519,
     NONBROADCAST = 520,
     NBMA = 521,
     POINTOPOINT = 522,
     PTP = 523,
     POINTOMULTIPOINT = 524,
     PTMP = 525,
     SIMPLE = 526,
     AUTHENTICATION = 527,
     STRICT = 528,
     CRYPTOGRAPHIC = 529,
     ELIGIBLE = 530,
     POLL = 531,
     NETWORKS = 532,
     HIDDEN = 533,
     VIRTUAL = 534,
     LINK = 535,
     RX = 536,
     BUFFER = 537,
     LARGE = 538,
     NORMAL = 539,
     STUBNET = 540,
     TAG = 541,
     EXTERNAL = 542,
     LSADB = 543,
     ECMP = 544,
     WEIGHT = 545,
     NSSA = 546,
     TRANSLATOR = 547,
     STABILITY = 548,
     GLOBAL = 549,
     LSID = 550,
     INSTANCE = 551,
     REAL = 552,
     TOPOLOGY = 553,
     STATE = 554,
     PIPE = 555,
     PEER = 556,
     MODE = 557,
     OPAQUE = 558,
     TRANSPARENT = 559,
     RIP = 560,
     INFINITY = 561,
     PERIOD = 562,
     GARBAGE = 563,
     MULTICAST = 564,
     QUIET = 565,
     NOLISTEN = 566,
     VERSION1 = 567,
     PLAINTEXT = 568,
     MD5 = 569,
     HONOR = 570,
     NEVER = 571,
     ALWAYS = 572,
     RIP_METRIC = 573,
     RIP_TAG = 574,
     STATIC = 575,
     PROHIBIT = 576,
     MULTIPATH = 577,
     BLACKHOLE = 578,
     UNREACHABLE = 579
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 470 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 293 of yacc.c  */
#line 936 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 948 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  64
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2524

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  346
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  234
/* YYNRULES -- Number of rules.  */
#define YYNRULES  758
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1421

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   579

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     336,   337,    28,    26,   342,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   339,   338,
      23,    22,    24,   343,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   344,     2,   345,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   340,     2,   341,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      49,    52,    55,    57,    59,    62,    65,    67,    69,    70,
      75,    78,    79,    81,    84,    86,    88,    92,    94,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   121,
     125,   127,   129,   131,   133,   136,   141,   145,   149,   153,
     158,   164,   168,   172,   177,   180,   181,   183,   184,   186,
     189,   192,   195,   199,   202,   206,   209,   213,   217,   221,
     226,   232,   234,   236,   238,   243,   244,   247,   250,   253,
     255,   257,   258,   260,   264,   268,   269,   278,   280,   285,
     287,   289,   290,   292,   296,   297,   300,   303,   306,   309,
     312,   315,   319,   323,   327,   332,   335,   339,   342,   345,
     347,   349,   351,   352,   355,   358,   361,   364,   367,   369,
     373,   377,   378,   380,   382,   385,   386,   388,   392,   394,
     398,   399,   402,   405,   409,   413,   417,   418,   422,   424,
     426,   430,   432,   436,   438,   440,   442,   444,   446,   448,
     450,   452,   456,   458,   462,   464,   466,   471,   473,   474,
     478,   483,   485,   488,   489,   495,   501,   507,   513,   518,
     522,   526,   531,   537,   539,   540,   544,   549,   554,   555,
     558,   562,   566,   570,   573,   576,   579,   582,   586,   590,
     593,   596,   598,   600,   605,   606,   610,   614,   618,   619,
     621,   623,   628,   629,   632,   635,   638,   641,   644,   647,
     650,   651,   654,   664,   674,   679,   683,   687,   691,   695,
     699,   703,   707,   712,   714,   716,   718,   719,   721,   725,
     729,   733,   737,   742,   747,   752,   757,   760,   762,   764,
     766,   768,   769,   771,   772,   777,   780,   782,   784,   786,
     788,   790,   792,   794,   796,   798,   800,   802,   804,   807,
     810,   811,   815,   817,   821,   823,   825,   827,   830,   834,
     837,   842,   843,   849,   850,   852,   854,   857,   859,   863,
     865,   867,   869,   871,   873,   875,   879,   881,   883,   885,
     887,   889,   893,   895,   901,   913,   915,   917,   919,   922,
     924,   932,   942,   950,   952,   954,   956,   960,   962,   964,
     966,   970,   972,   976,   978,   982,   986,   988,   991,   994,
    1001,  1003,  1007,  1008,  1013,  1017,  1019,  1023,  1027,  1031,
    1034,  1037,  1040,  1043,  1044,  1047,  1050,  1051,  1053,  1055,
    1057,  1059,  1061,  1063,  1065,  1069,  1073,  1075,  1077,  1083,
    1091,  1092,  1097,  1099,  1101,  1103,  1105,  1107,  1109,  1111,
    1113,  1115,  1119,  1123,  1127,  1131,  1135,  1139,  1143,  1147,
    1151,  1155,  1159,  1163,  1167,  1171,  1174,  1179,  1181,  1183,
    1185,  1187,  1190,  1193,  1197,  1201,  1208,  1212,  1216,  1220,
    1224,  1230,  1237,  1244,  1251,  1258,  1263,  1272,  1277,  1279,
    1281,  1283,  1285,  1287,  1289,  1291,  1292,  1294,  1298,  1300,
    1304,  1305,  1307,  1312,  1319,  1324,  1328,  1334,  1340,  1345,
    1352,  1356,  1359,  1365,  1371,  1380,  1389,  1398,  1407,  1410,
    1414,  1418,  1424,  1431,  1439,  1446,  1451,  1456,  1462,  1469,
    1476,  1482,  1486,  1491,  1497,  1503,  1509,  1515,  1520,  1525,
    1531,  1537,  1543,  1549,  1555,  1561,  1567,  1573,  1580,  1587,
    1596,  1603,  1610,  1616,  1621,  1627,  1632,  1638,  1643,  1649,
    1654,  1660,  1666,  1669,  1673,  1677,  1679,  1682,  1685,  1690,
    1693,  1695,  1698,  1703,  1704,  1708,  1711,  1713,  1716,  1720,
    1724,  1728,  1732,  1735,  1739,  1740,  1746,  1747,  1753,  1756,
    1759,  1761,  1766,  1768,  1770,  1771,  1775,  1778,  1781,  1784,
    1790,  1793,  1794,  1798,  1799,  1802,  1805,  1809,  1812,  1815,
    1819,  1822,  1825,  1828,  1830,  1834,  1837,  1840,  1843,  1846,
    1849,  1852,  1856,  1859,  1862,  1865,  1868,  1871,  1874,  1877,
    1880,  1884,  1888,  1891,  1895,  1898,  1902,  1906,  1911,  1914,
    1917,  1920,  1924,  1928,  1932,  1934,  1935,  1938,  1942,  1944,
    1945,  1947,  1950,  1951,  1954,  1956,  1958,  1961,  1965,  1966,
    1967,  1970,  1971,  1975,  1976,  1980,  1985,  1987,  1988,  1993,
    2000,  2007,  2014,  2022,  2029,  2037,  2043,  2044,  2047,  2051,
    2054,  2058,  2062,  2065,  2069,  2072,  2075,  2079,  2083,  2089,
    2094,  2099,  2102,  2106,  2110,  2115,  2120,  2125,  2131,  2137,
    2142,  2146,  2151,  2156,  2161,  2166,  2168,  2170,  2172,  2174,
    2176,  2178,  2180,  2182,  2183,  2186,  2189,  2190,  2194,  2195,
    2199,  2200,  2204,  2207,  2211,  2215,  2221,  2227,  2231,  2234,
    2238,  2242,  2244,  2247,  2252,  2256,  2260,  2264,  2267,  2270,
    2273,  2276,  2279,  2284,  2286,  2288,  2290,  2292,  2294,  2296,
    2298,  2300,  2302,  2304,  2306,  2308,  2310,  2312,  2314,  2316,
    2318,  2320,  2322,  2324,  2326,  2328,  2330,  2332,  2334,  2336,
    2338,  2340,  2342,  2344,  2346,  2348,  2350,  2352,  2354,  2356,
    2358,  2360,  2362,  2364,  2366,  2368,  2370,  2372,  2374,  2376,
    2378,  2380,  2382,  2384,  2386,  2388,  2390,  2392,  2394,  2396,
    2398,  2400,  2403,  2406,  2409,  2412,  2415,  2418,  2421,  2424,
    2428,  2432,  2436,  2440,  2444,  2448,  2452,  2454,  2456,  2458,
    2460,  2462,  2464,  2466,  2468,  2470,  2472,  2474,  2476,  2478,
    2480,  2482,  2484,  2486,  2488,  2490,  2492,  2494,  2496
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     347,     0,    -1,   348,     3,    -1,     4,   575,    -1,    -1,
     348,   574,    -1,    15,    -1,   336,   506,   337,    -1,    19,
      -1,    33,    19,    22,   349,   338,    -1,    33,    19,    22,
      18,   338,    -1,   349,    -1,    34,    -1,    36,    -1,    35,
      -1,    37,    -1,    -1,    18,    -1,    19,    -1,    -1,    30,
      19,    -1,   352,   356,    -1,   354,    -1,   352,    -1,    29,
     349,    -1,   339,   352,    -1,    20,    -1,    20,    -1,    -1,
      38,   361,   362,   338,    -1,    57,    20,    -1,    -1,    20,
      -1,    39,   360,    -1,    50,    -1,    40,    -1,   340,   363,
     341,    -1,   364,    -1,   363,   342,   364,    -1,    41,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,   130,   106,   414,   338,
      -1,   130,    20,   338,    -1,   138,    -1,    79,    -1,    56,
      -1,    38,    -1,   366,    20,    -1,   366,    20,   349,    20,
      -1,   366,    53,    54,    -1,   366,    53,    55,    -1,    52,
     367,   338,    -1,    62,   375,   376,     3,    -1,    62,    51,
     375,   376,     3,    -1,    62,    58,     3,    -1,    62,    59,
       3,    -1,    62,    60,   375,     3,    -1,    63,     3,    -1,
      -1,    20,    -1,    -1,    61,    -1,    61,   349,    -1,   392,
      64,    -1,    65,   351,    -1,    66,    67,   349,    -1,    68,
     351,    -1,    69,    70,   351,    -1,   392,    69,    -1,    66,
      67,   349,    -1,   108,   358,   355,    -1,    64,    74,   349,
      -1,    77,    78,   383,   338,    -1,    77,    78,   101,   406,
     338,    -1,    15,    -1,    17,    -1,    18,    -1,   118,   119,
     385,   338,    -1,    -1,   385,   386,    -1,   122,   352,    -1,
     123,   349,    -1,   120,    -1,   121,    -1,    -1,   126,    -1,
      74,    19,   387,    -1,   115,    74,    19,    -1,    -1,   390,
     115,   354,   116,    15,   202,    15,   338,    -1,   389,    -1,
     389,   340,   390,   341,    -1,    79,    -1,    80,    -1,    -1,
      19,    -1,    19,   101,    19,    -1,    -1,    81,   349,    -1,
      82,   351,    -1,    41,   411,    -1,   130,   414,    -1,    85,
     395,    -1,    86,   395,    -1,    91,    92,   397,    -1,    85,
      92,   397,    -1,    86,    92,   397,    -1,    85,    98,    99,
     351,    -1,    74,   398,    -1,    77,    78,   383,    -1,   125,
      20,    -1,    87,   470,    -1,   471,    -1,    40,    -1,    88,
      -1,    -1,    93,    94,    -1,    93,    95,    -1,    93,    96,
      -1,    93,    97,    -1,   349,   396,    -1,    19,    -1,    41,
     106,   411,    -1,    41,   112,   349,    -1,    -1,    20,    -1,
     355,    -1,    20,   355,    -1,    -1,    27,    -1,   400,   402,
     401,    -1,   403,    -1,   404,   342,   403,    -1,    -1,   405,
     404,    -1,   392,    83,    -1,   407,   393,   340,    -1,   408,
     394,   338,    -1,   408,   410,   338,    -1,    -1,    84,   409,
     404,    -1,    40,    -1,    35,    -1,   340,   412,   341,    -1,
     413,    -1,   412,   342,   413,    -1,    89,    -1,    70,    -1,
      90,    -1,   107,    -1,   104,    -1,   105,    -1,    40,    -1,
      35,    -1,   340,   415,   341,    -1,   416,    -1,   415,   342,
     416,    -1,    89,    -1,   131,    -1,   124,   340,   418,   341,
      -1,   419,    -1,    -1,   419,   338,   418,    -1,   420,   340,
     421,   341,    -1,   420,    -1,   100,    20,    -1,    -1,   114,
     101,   357,   338,   421,    -1,   114,   103,   357,   338,   421,
      -1,   154,   101,   357,   338,   421,    -1,   154,   103,   357,
     338,   421,    -1,    78,   349,   338,   421,    -1,   135,   136,
       3,    -1,   135,   133,     3,    -1,   135,   106,   461,     3,
      -1,   135,   106,    40,   461,     3,    -1,    19,    -1,    -1,
     135,   107,     3,    -1,   135,   107,   137,     3,    -1,   135,
     138,   430,     3,    -1,    -1,   430,   354,    -1,   430,   111,
     355,    -1,   430,    74,    19,    -1,   430,    87,   470,    -1,
     430,   471,    -1,   430,    40,    -1,   430,   108,    -1,   430,
      99,    -1,   430,   431,    19,    -1,   430,    79,    19,    -1,
     430,   109,    -1,   430,   110,    -1,   113,    -1,    86,    -1,
     135,   115,   433,     3,    -1,    -1,   433,   434,   354,    -1,
     433,   202,    15,    -1,   433,    74,    19,    -1,    -1,   128,
      -1,   111,    -1,   135,   139,   436,     3,    -1,    -1,   436,
      74,    -1,   436,   149,    -1,   436,    87,    -1,   436,    79,
      -1,   436,    80,    -1,   436,   115,    -1,   436,    19,    -1,
      -1,    74,    19,    -1,   140,   115,   354,   116,    15,   202,
      15,   437,     3,    -1,   141,   115,   354,   116,    15,   202,
      15,   437,     3,    -1,   117,   115,   437,     3,    -1,   142,
     143,     3,    -1,   142,   144,     3,    -1,   142,   107,     3,
      -1,   142,   145,     3,    -1,   142,   146,     3,    -1,   142,
      70,     3,    -1,   142,   106,     3,    -1,   147,   449,   450,
       3,    -1,    40,    -1,    35,    -1,    15,    -1,    -1,    15,
      -1,    97,   460,     3,    -1,   148,   460,     3,    -1,    96,
     460,     3,    -1,   127,   460,     3,    -1,   127,   128,   460,
       3,    -1,   127,   129,   460,     3,    -1,    41,   460,   411,
       3,    -1,   130,   460,   414,     3,    -1,   132,     3,    -1,
      19,    -1,    40,    -1,    20,    -1,    19,    -1,    -1,    20,
      -1,    -1,    87,    19,   463,   469,    -1,   199,   506,    -1,
     157,    -1,   158,    -1,   159,    -1,   160,    -1,   161,    -1,
     162,    -1,   163,    -1,   165,    -1,   166,    -1,   167,    -1,
     168,    -1,   169,    -1,   465,   164,    -1,   465,    19,    -1,
      -1,   466,   338,   467,    -1,   466,    -1,   466,   338,   468,
      -1,   473,    -1,    19,    -1,   469,    -1,   198,   506,    -1,
     336,   468,   337,    -1,   336,   337,    -1,   467,   340,   476,
     341,    -1,    -1,   149,    19,   475,   472,   473,    -1,    -1,
     477,    -1,   512,    -1,   477,   512,    -1,   512,    -1,   340,
     476,   341,    -1,    18,    -1,   349,    -1,    17,    -1,   479,
      -1,    16,    -1,    15,    -1,   336,   506,   337,    -1,    17,
      -1,   479,    -1,    16,    -1,   506,    -1,   482,    -1,   482,
       7,   482,    -1,    28,    -1,   336,   483,   342,   483,   337,
      -1,   336,   483,   342,   483,   337,     7,   336,   482,   342,
     482,   337,    -1,   506,    -1,   176,    -1,   177,    -1,   178,
      15,    -1,   179,    -1,   336,   486,   342,   485,   342,   485,
     337,    -1,   336,   486,   342,   485,   342,   485,     7,   485,
     337,    -1,   336,   486,   342,   485,   342,    28,   337,    -1,
     484,    -1,   487,    -1,   480,    -1,   480,     7,   480,    -1,
     484,    -1,   487,    -1,   481,    -1,   481,     7,   481,    -1,
     488,    -1,   490,   342,   488,    -1,   489,    -1,   491,   342,
     489,    -1,    18,    29,    15,    -1,   492,    -1,   492,    26,
      -1,   492,    27,    -1,   492,   340,    15,   342,    15,   341,
      -1,   493,    -1,   494,   342,   493,    -1,    -1,   495,   491,
     339,   476,    -1,   495,     6,   476,    -1,   504,    -1,   336,
     506,   337,    -1,    13,   498,    14,    -1,    29,   499,    29,
      -1,    15,   498,    -1,    28,   498,    -1,   343,   498,    -1,
     496,   498,    -1,    -1,    15,   499,    -1,   343,   499,    -1,
      -1,    15,    -1,   174,    -1,   175,    -1,    20,    -1,   479,
      -1,   492,    -1,    17,    -1,   344,   490,   345,    -1,   344,
     494,   345,    -1,    16,    -1,   497,    -1,   336,   506,   342,
     506,   337,    -1,   336,   486,   342,   506,   342,   506,   337,
      -1,    -1,    19,   336,   511,   337,    -1,    19,    -1,   101,
      -1,   180,    -1,   181,    -1,   183,    -1,   184,    -1,   185,
      -1,   186,    -1,   187,    -1,   336,   506,   337,    -1,   506,
      26,   506,    -1,   506,    27,   506,    -1,   506,    28,   506,
      -1,   506,    29,   506,    -1,   506,    11,   506,    -1,   506,
      12,   506,    -1,   506,    22,   506,    -1,   506,    10,   506,
      -1,   506,    23,   506,    -1,   506,     9,   506,    -1,   506,
      24,   506,    -1,   506,     8,   506,    -1,   506,    25,   506,
      -1,    31,   506,    -1,   189,   336,   506,   337,    -1,   504,
      -1,   500,    -1,   501,    -1,    81,    -1,   502,   505,    -1,
     502,   579,    -1,   506,    32,   159,    -1,   506,    32,   188,
      -1,   506,    32,   182,   336,   506,   337,    -1,   506,    32,
     193,    -1,   506,    32,   194,    -1,    26,   197,    26,    -1,
      27,   197,    27,    -1,    27,    27,   197,    27,    27,    -1,
     192,   336,   506,   342,   506,   337,    -1,   140,   336,   506,
     342,   506,   337,    -1,   141,   336,   506,   342,   506,   337,
      -1,    87,   336,   506,   342,   506,   337,    -1,   196,   336,
      19,   337,    -1,   196,   336,    19,   342,   506,   342,   506,
     337,    -1,    19,   336,   511,   337,    -1,   156,    -1,   154,
      -1,   155,    -1,    46,    -1,   150,    -1,   151,    -1,   506,
      -1,    -1,   508,    -1,   508,   342,   509,    -1,   506,    -1,
     506,   342,   510,    -1,    -1,   510,    -1,   170,   506,   171,
     478,    -1,   170,   506,   171,   478,   172,   478,    -1,    19,
      22,   506,   338,    -1,   153,   506,   338,    -1,   502,   579,
      22,   506,   338,    -1,   502,   505,    22,   506,   338,    -1,
      81,    22,   506,   338,    -1,   152,   336,   502,   579,   337,
     338,    -1,   507,   509,   338,    -1,   503,   338,    -1,   173,
     506,   340,   495,   341,    -1,   502,   579,    32,   197,   338,
      -1,   502,   579,    32,   192,   336,   506,   337,   338,    -1,
     502,   579,    32,   140,   336,   506,   337,   338,    -1,   502,
     579,    32,   141,   336,   506,   337,   338,    -1,   502,   579,
      32,    87,   336,   506,   337,   338,    -1,   392,   119,    -1,
     513,   393,   340,    -1,   514,   394,   338,    -1,   514,   200,
     202,   349,   338,    -1,   514,   200,   352,   202,   349,   338,
      -1,   514,   201,   352,   353,   202,   349,   338,    -1,   514,
     230,   233,    78,   383,   338,    -1,   514,   230,   232,   338,
      -1,   514,   231,   232,   338,    -1,   514,   203,    67,   349,
     338,    -1,   514,   208,   203,    67,   349,   338,    -1,   514,
     204,   205,    67,   349,   338,    -1,   514,   206,    67,   349,
     338,    -1,   514,   207,   338,    -1,   514,   207,   349,   338,
      -1,   514,   210,   211,   212,   338,    -1,   514,   240,   241,
     212,   338,    -1,   514,   240,   241,   242,   338,    -1,   514,
     240,   241,   243,   338,    -1,   514,   250,    83,   338,    -1,
     514,   250,   251,   338,    -1,   514,   214,   215,   351,   338,
      -1,   514,   252,   215,   351,   338,    -1,   514,   249,   215,
     351,   338,    -1,   514,   238,   239,   351,   338,    -1,   514,
     255,   252,   351,   338,    -1,   514,   213,   223,   349,   338,
      -1,   514,   213,   222,   349,   338,    -1,   514,   184,   122,
     352,   338,    -1,   514,   216,   217,    67,   349,   338,    -1,
     514,    46,   218,    67,   349,   338,    -1,   514,    46,   219,
      67,   349,   342,   349,   338,    -1,   514,    97,   220,    46,
     351,   338,    -1,   514,   148,   138,   244,   351,   338,    -1,
     514,   148,   234,   351,   338,    -1,   514,   237,   351,   338,
      -1,   514,   235,   236,   351,   338,    -1,   514,   100,    20,
     338,    -1,   514,   138,    92,   349,   338,    -1,   514,   102,
     351,   338,    -1,   514,   245,   246,   351,   338,    -1,   514,
     256,   351,   338,    -1,   514,   249,    74,   398,   338,    -1,
     514,   253,   254,   351,   338,    -1,   392,   257,    -1,   515,
     393,   340,    -1,   516,   517,   338,    -1,   394,    -1,   263,
     351,    -1,   300,   351,    -1,   300,   351,    92,   349,    -1,
     265,   349,    -1,   519,    -1,   258,   383,    -1,   518,   340,
     520,   341,    -1,    -1,   520,   521,   338,    -1,   264,   351,
      -1,   302,    -1,   137,   351,    -1,   213,   302,   351,    -1,
     213,   266,   349,    -1,   213,   267,   349,    -1,   264,   266,
     349,    -1,   303,   351,    -1,   303,   304,   349,    -1,    -1,
     288,   522,   340,   533,   341,    -1,    -1,   298,   523,   340,
     533,   341,    -1,   296,   524,    -1,    84,   545,    -1,   528,
      -1,   525,   340,   526,   341,    -1,   525,    -1,   354,    -1,
      -1,   526,   527,   338,    -1,   289,   351,    -1,   137,   351,
      -1,   266,   349,    -1,   531,   542,   340,   529,   341,    -1,
     531,   542,    -1,    -1,   529,   530,   338,    -1,    -1,   269,
     349,    -1,   268,   349,    -1,   270,   217,   349,    -1,   219,
     349,    -1,   272,   349,    -1,   272,   110,   349,    -1,   283,
      88,    -1,   283,   282,    -1,   283,   285,    -1,   417,    -1,
     290,   291,   383,    -1,   266,   349,    -1,   269,   349,    -1,
     287,   349,    -1,   268,   349,    -1,   219,   349,    -1,   272,
     349,    -1,   272,   110,   349,    -1,   273,   274,    -1,   273,
     275,    -1,   273,   276,    -1,   273,   277,    -1,   273,   278,
      -1,   273,   279,    -1,   273,   280,    -1,   273,   281,    -1,
     308,   274,   351,    -1,   270,   217,   349,    -1,   271,   349,
      -1,   284,   276,   351,    -1,   264,   351,    -1,    60,   291,
     351,    -1,   300,   301,   349,    -1,   145,   340,   537,   341,
      -1,   283,    88,    -1,   283,   282,    -1,   283,   285,    -1,
     292,   293,   294,    -1,   292,   293,   295,    -1,   292,   293,
     349,    -1,   417,    -1,    -1,   533,   534,    -1,   535,   536,
     338,    -1,   354,    -1,    -1,   289,    -1,   297,   349,    -1,
      -1,   537,   538,    -1,   539,    -1,   540,    -1,    18,   338,
      -1,    18,   286,   338,    -1,    -1,    -1,   307,   349,    -1,
      -1,   543,   532,   338,    -1,    -1,   340,   543,   341,    -1,
     541,   404,   542,   544,    -1,    20,    -1,    -1,   135,   257,
     426,     3,    -1,   135,   257,   145,   426,   546,     3,    -1,
     135,   257,    84,   426,   546,     3,    -1,   135,   257,   309,
     426,   546,     3,    -1,   135,   257,   309,    40,   426,   546,
       3,    -1,   135,   257,   310,   426,   546,     3,    -1,   135,
     257,   310,    40,   426,   546,     3,    -1,   135,   257,   299,
     555,     3,    -1,    -1,   555,   305,    -1,   555,   258,   383,
      -1,   555,   291,    -1,   555,   273,    15,    -1,   555,   306,
     383,    -1,   555,   212,    -1,   555,    77,   383,    -1,   555,
      19,    -1,   392,   311,    -1,   556,   393,   340,    -1,   557,
     394,   338,    -1,   557,   312,    74,    19,   338,    -1,   557,
     313,   314,   338,    -1,   557,   313,   315,   338,    -1,   392,
     316,    -1,   558,   393,   340,    -1,   559,   394,   338,    -1,
     559,   317,   349,   338,    -1,   559,   123,   349,   338,    -1,
     559,   318,   349,   338,    -1,   559,   319,    67,   349,   338,
      -1,   559,    61,    67,   349,   338,    -1,   559,   283,   560,
     338,    -1,   559,   417,   338,    -1,   559,   326,   328,   338,
      -1,   559,   326,   201,   338,    -1,   559,   326,   327,   338,
      -1,   559,    84,   566,   338,    -1,   324,    -1,   325,    -1,
      88,    -1,   274,    -1,   320,    -1,   321,    -1,   322,    -1,
     323,    -1,    -1,   215,   349,    -1,   313,   561,    -1,    -1,
     563,   562,   338,    -1,    -1,   340,   563,   341,    -1,    -1,
     565,   404,   564,    -1,   392,   331,    -1,   567,   393,   340,
      -1,   568,   394,   338,    -1,   568,    60,   291,   351,   338,
      -1,   568,   249,    74,   398,   338,    -1,   568,   572,   338,
      -1,   138,   354,    -1,   209,   352,   353,    -1,   570,   301,
     349,    -1,   570,    -1,   571,   570,    -1,   569,   209,   352,
     353,    -1,   569,   209,    20,    -1,   569,   333,   571,    -1,
     569,   251,   352,    -1,   569,   242,    -1,   569,   155,    -1,
     569,   334,    -1,   569,   335,    -1,   569,   332,    -1,   135,
     331,   426,     3,    -1,   338,    -1,   350,    -1,   359,    -1,
     365,    -1,   368,    -1,   382,    -1,   384,    -1,   388,    -1,
     391,    -1,   576,    -1,   399,    -1,   462,    -1,   464,    -1,
     474,    -1,   369,    -1,   370,    -1,   371,    -1,   372,    -1,
     373,    -1,   374,    -1,   422,    -1,   423,    -1,   424,    -1,
     425,    -1,   427,    -1,   428,    -1,   429,    -1,   432,    -1,
     435,    -1,   438,    -1,   439,    -1,   440,    -1,   441,    -1,
     442,    -1,   443,    -1,   444,    -1,   445,    -1,   446,    -1,
     447,    -1,   448,    -1,   451,    -1,   452,    -1,   453,    -1,
     454,    -1,   455,    -1,   456,    -1,   457,    -1,   458,    -1,
     459,    -1,   547,    -1,   548,    -1,   549,    -1,   550,    -1,
     551,    -1,   552,    -1,   553,    -1,   554,    -1,   573,    -1,
     577,   341,    -1,   578,   341,    -1,   408,   341,    -1,   514,
     341,    -1,   516,   341,    -1,   557,   341,    -1,   559,   341,
      -1,   568,   341,    -1,   377,   393,   340,    -1,   577,   394,
     338,    -1,   577,   378,   338,    -1,   577,   381,   338,    -1,
     379,   393,   340,    -1,   578,   394,   338,    -1,   578,   380,
     338,    -1,    71,    -1,    72,    -1,    75,    -1,    76,    -1,
     134,    -1,     5,    -1,   224,    -1,   221,    -1,   225,    -1,
     223,    -1,   222,    -1,   226,    -1,   227,    -1,   228,    -1,
     247,    -1,   248,    -1,   229,    -1,   259,    -1,   260,    -1,
     261,    -1,   262,    -1,   329,    -1,   330,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   644,   644,   645,   648,   650,   657,   658,   659,   665,
     669,   678,   679,   680,   681,   682,   683,   689,   690,   697,
     698,   702,   709,   710,   714,   718,   725,   733,   734,   740,
     749,   750,   754,   759,   760,   764,   765,   769,   770,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   788,   789,
     798,   799,   800,   801,   804,   805,   806,   807,   811,   818,
     821,   828,   831,   834,   837,   841,   842,   846,   847,   848,
     856,   861,   862,   866,   873,   879,   884,   888,   902,   916,
     917,   921,   922,   923,   934,   936,   938,   942,   943,   944,
     945,   952,   953,   957,   965,   969,   971,   977,   978,   985,
     986,   990,   996,  1000,  1010,  1012,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1031,  1032,
    1033,  1034,  1038,  1039,  1040,  1041,  1042,  1046,  1055,  1063,
    1064,  1072,  1080,  1081,  1082,  1086,  1087,  1091,  1096,  1097,
    1100,  1108,  1115,  1122,  1123,  1124,  1128,  1136,  1142,  1143,
    1144,  1148,  1149,  1153,  1154,  1155,  1156,  1157,  1158,  1164,
    1165,  1166,  1170,  1171,  1175,  1176,  1182,  1183,  1186,  1188,
    1192,  1193,  1197,  1215,  1216,  1217,  1218,  1219,  1220,  1228,
    1231,  1234,  1237,  1241,  1242,  1245,  1248,  1252,  1256,  1262,
    1268,  1275,  1280,  1285,  1290,  1294,  1298,  1302,  1312,  1320,
    1324,  1331,  1332,  1337,  1341,  1348,  1355,  1359,  1367,  1368,
    1369,  1374,  1378,  1381,  1382,  1383,  1384,  1385,  1386,  1387,
    1392,  1397,  1405,  1412,  1419,  1427,  1429,  1431,  1433,  1435,
    1437,  1439,  1442,  1448,  1449,  1450,  1454,  1455,  1461,  1463,
    1465,  1467,  1469,  1471,  1475,  1479,  1482,  1486,  1487,  1488,
    1492,  1493,  1494,  1502,  1502,  1512,  1516,  1517,  1518,  1519,
    1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,  1528,  1549,
    1560,  1561,  1568,  1569,  1576,  1585,  1589,  1593,  1617,  1618,
    1622,  1635,  1635,  1651,  1652,  1655,  1656,  1660,  1663,  1672,
    1685,  1686,  1687,  1688,  1692,  1693,  1694,  1695,  1696,  1700,
    1703,  1704,  1705,  1709,  1712,  1721,  1724,  1725,  1726,  1727,
    1731,  1732,  1733,  1737,  1738,  1739,  1740,  1744,  1745,  1746,
    1747,  1751,  1752,  1756,  1757,  1761,  1768,  1769,  1770,  1771,
    1778,  1779,  1782,  1783,  1790,  1802,  1803,  1807,  1808,  1812,
    1813,  1814,  1815,  1816,  1820,  1821,  1822,  1826,  1827,  1828,
    1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1840,  1841,
    1851,  1855,  1878,  1914,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,
    1935,  1936,  1937,  1938,  1939,  1940,  1941,  1943,  1944,  1945,
    1947,  1949,  1951,  1953,  1954,  1955,  1956,  1957,  1967,  1968,
    1969,  1970,  1971,  1972,  1973,  1975,  1976,  1981,  2004,  2005,
    2006,  2007,  2008,  2009,  2013,  2016,  2017,  2018,  2026,  2033,
    2042,  2043,  2047,  2053,  2063,  2072,  2078,  2083,  2090,  2095,
    2101,  2102,  2103,  2111,  2112,  2113,  2114,  2115,  2121,  2142,
    2143,  2144,  2145,  2146,  2156,  2157,  2158,  2159,  2160,  2161,
    2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,
    2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,
    2182,  2183,  2184,  2185,  2186,  2187,  2188,  2193,  2194,  2195,
    2196,  2197,  2208,  2218,  2219,  2223,  2224,  2225,  2226,  2227,
    2228,  2231,  2246,  2249,  2251,  2255,  2256,  2257,  2258,  2259,
    2260,  2261,  2262,  2263,  2264,  2264,  2265,  2265,  2266,  2267,
    2268,  2272,  2273,  2277,  2285,  2287,  2291,  2292,  2293,  2297,
    2298,  2301,  2303,  2306,  2307,  2308,  2309,  2310,  2311,  2312,
    2313,  2314,  2315,  2316,  2319,  2341,  2342,  2343,  2344,  2345,
    2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,
    2366,  2367,  2368,  2369,  2370,  2373,  2375,  2378,  2380,  2389,
    2391,  2392,  2395,  2397,  2401,  2402,  2404,  2413,  2424,  2444,
    2446,  2449,  2451,  2454,  2456,  2460,  2464,  2465,  2470,  2473,
    2476,  2481,  2484,  2489,  2492,  2496,  2500,  2503,  2504,  2505,
    2506,  2507,  2508,  2509,  2510,  2516,  2523,  2524,  2525,  2530,
    2531,  2537,  2544,  2545,  2546,  2547,  2548,  2549,  2550,  2551,
    2552,  2553,  2554,  2555,  2556,  2560,  2561,  2562,  2567,  2568,
    2569,  2570,  2571,  2574,  2575,  2576,  2579,  2581,  2584,  2586,
    2590,  2599,  2606,  2613,  2614,  2615,  2616,  2617,  2620,  2629,
    2637,  2644,  2645,  2649,  2654,  2660,  2663,  2668,  2669,  2670,
    2671,  2672,  2675,  2682,  2682,  2682,  2682,  2682,  2682,  2682,
    2682,  2682,  2682,  2682,  2682,  2682,  2682,  2683,  2683,  2683,
    2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,
    2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,
    2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,
    2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,  2683,
    2683,  2684,  2684,  2684,  2684,  2684,  2684,  2684,  2684,  2685,
    2685,  2685,  2685,  2686,  2686,  2686,  2687,  2687,  2687,  2687,
    2687,  2688,  2688,  2689,  2690,  2691,  2692,  2693,  2694,  2695,
    2696,  2697,  2698,  2699,  2699,  2699,  2699,  2699,  2699
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIRM",
  "UNDO", "CHECK", "TIMEOUT", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "KRT_SOURCE", "KRT_METRIC",
  "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "ROA", "MAX", "FLUSH", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION",
  "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT",
  "MEMORY", "IGP_METRIC", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET",
  "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX",
  "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST",
  "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "LEN", "DEFINED", "CONTAINS", "RESET", "PREPEND",
  "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE", "EVAL", "LOCAL",
  "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP",
  "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC",
  "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE",
  "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN",
  "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "'('", "')'", "';'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "expr", "definition", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "tab_sorted", "newtab", "roa_table_start", "roa_table_opts", "roa_table",
  "proto_start", "proto_name", "proto_item", "imexport", "limit_action",
  "limit_spec", "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_init", "iface_patt", "dev_proto_start",
  "dev_proto", "dev_iface_init", "dev_iface_patt", "debug_mask",
  "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE",
  "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT",
  "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "pair_expr", "pair_atom", "pair_item",
  "ec_expr", "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "ipa_list", "ipa_item", "ipa_el", "ipa_ne",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,    40,    41,    59,    58,
     123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   346,   347,   347,   348,   348,   349,   349,   349,   350,
     350,   351,   351,   351,   351,   351,   351,   352,   352,   353,
     353,   354,   355,   355,   356,   356,   357,   358,   358,   359,
     360,   360,   361,   361,   361,   362,   362,   363,   363,   364,
     364,   364,   364,   364,   364,   364,   364,   364,   365,   365,
     366,   366,   366,   366,   367,   367,   367,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   375,   376,   376,   376,
     377,   378,   378,   378,   378,   379,   380,   380,   381,   382,
     382,   383,   383,   383,   384,   385,   385,   386,   386,   386,
     386,   387,   387,   388,   389,   390,   390,   391,   391,   392,
     392,   393,   393,   393,   394,   394,   394,   394,   394,   394,
     394,   394,   394,   394,   394,   394,   394,   394,   395,   395,
     395,   395,   396,   396,   396,   396,   396,   397,   398,   399,
     399,   400,   401,   401,   401,   402,   402,   403,   404,   404,
     405,   406,   407,   408,   408,   408,   409,   410,   411,   411,
     411,   412,   412,   413,   413,   413,   413,   413,   413,   414,
     414,   414,   415,   415,   416,   416,   417,   417,   418,   418,
     419,   419,   420,   421,   421,   421,   421,   421,   421,   422,
     423,   424,   425,   426,   426,   427,   428,   429,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   431,   431,   432,   433,   433,   433,   433,   434,   434,
     434,   435,   436,   436,   436,   436,   436,   436,   436,   436,
     437,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   449,   449,   450,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   460,   460,
     461,   461,   461,   463,   462,   464,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   466,
     467,   467,   468,   468,   469,   470,   470,   471,   472,   472,
     473,   475,   474,   476,   476,   477,   477,   478,   478,   479,
     480,   480,   480,   480,   481,   481,   481,   481,   481,   482,
     483,   483,   483,   484,   484,   485,   486,   486,   486,   486,
     487,   487,   487,   488,   488,   488,   488,   489,   489,   489,
     489,   490,   490,   491,   491,   492,   493,   493,   493,   493,
     494,   494,   495,   495,   495,   496,   496,   497,   497,   498,
     498,   498,   498,   498,   499,   499,   499,   500,   500,   500,
     500,   500,   500,   500,   500,   500,   500,   500,   501,   501,
     502,   503,   504,   505,   505,   505,   505,   505,   505,   505,
     505,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   507,   507,
     507,   507,   507,   507,   508,   509,   509,   509,   510,   510,
     511,   511,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   513,   514,
     514,   514,   514,   514,   514,   514,   514,   514,   514,   514,
     514,   514,   514,   514,   514,   514,   514,   514,   514,   514,
     514,   514,   514,   514,   514,   514,   514,   514,   514,   514,
     514,   514,   514,   514,   514,   514,   514,   514,   514,   514,
     514,   514,   515,   516,   516,   517,   517,   517,   517,   517,
     517,   518,   519,   520,   520,   521,   521,   521,   521,   521,
     521,   521,   521,   521,   522,   521,   523,   521,   521,   521,
     521,   524,   524,   525,   526,   526,   527,   527,   527,   528,
     528,   529,   529,   530,   530,   530,   530,   530,   530,   530,
     530,   530,   530,   530,   531,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   533,   533,   534,   535,   536,
     536,   536,   537,   537,   538,   538,   539,   540,   541,   542,
     542,   543,   543,   544,   544,   545,   546,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   556,   557,   557,   557,   557,
     557,   558,   559,   559,   559,   559,   559,   559,   559,   559,
     559,   559,   559,   559,   559,   560,   560,   560,   561,   561,
     561,   561,   561,   562,   562,   562,   563,   563,   564,   564,
     565,   566,   567,   568,   568,   568,   568,   568,   569,   570,
     570,   571,   571,   572,   572,   572,   572,   572,   572,   572,
     572,   572,   573,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   576,   576,   576,   576,   576,   576,   576,   576,   577,
     577,   577,   577,   578,   578,   578,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     0,
       2,     2,     1,     1,     2,     2,     1,     1,     0,     4,
       2,     0,     1,     2,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       1,     1,     1,     1,     2,     4,     3,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     2,     3,     2,     3,     3,     3,     4,
       5,     1,     1,     1,     4,     0,     2,     2,     2,     1,
       1,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     3,
       3,     0,     1,     1,     2,     0,     1,     3,     1,     3,
       0,     2,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     4,     0,     3,     3,     3,     0,     1,
       1,     4,     0,     2,     2,     2,     2,     2,     2,     2,
       0,     2,     9,     9,     4,     3,     3,     3,     3,     3,
       3,     3,     4,     1,     1,     1,     0,     1,     3,     3,
       3,     3,     4,     4,     4,     4,     2,     1,     1,     1,
       1,     0,     1,     0,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       0,     3,     1,     3,     1,     1,     1,     2,     3,     2,
       4,     0,     5,     0,     1,     1,     2,     1,     3,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     3,     1,     5,    11,     1,     1,     1,     2,     1,
       7,     9,     7,     1,     1,     1,     3,     1,     1,     1,
       3,     1,     3,     1,     3,     3,     1,     2,     2,     6,
       1,     3,     0,     4,     3,     1,     3,     3,     3,     2,
       2,     2,     2,     0,     2,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     1,     5,     7,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     1,     1,     1,
       1,     2,     2,     3,     3,     6,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     3,
       3,     5,     6,     7,     6,     4,     4,     5,     6,     6,
       5,     3,     4,     5,     5,     5,     5,     4,     4,     5,
       5,     5,     5,     5,     5,     5,     5,     6,     6,     8,
       6,     6,     5,     4,     5,     4,     5,     4,     5,     4,
       5,     5,     2,     3,     3,     1,     2,     2,     4,     2,
       1,     2,     4,     0,     3,     2,     1,     2,     3,     3,
       3,     3,     2,     3,     0,     5,     0,     5,     2,     2,
       1,     4,     1,     1,     0,     3,     2,     2,     2,     5,
       2,     0,     3,     0,     2,     2,     3,     2,     2,     3,
       2,     2,     2,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     2,     3,     2,     3,     3,     4,     2,     2,
       2,     3,     3,     3,     1,     0,     2,     3,     1,     0,
       1,     2,     0,     2,     1,     1,     2,     3,     0,     0,
       2,     0,     3,     0,     3,     4,     1,     0,     4,     6,
       6,     6,     7,     6,     7,     5,     0,     2,     3,     2,
       3,     3,     2,     3,     2,     2,     3,     3,     5,     4,
       4,     2,     3,     3,     4,     4,     4,     5,     5,     4,
       3,     4,     4,     4,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     2,     0,     3,     0,     3,
       0,     3,     2,     3,     3,     5,     5,     3,     2,     3,
       3,     1,     2,     4,     3,     3,     3,     2,     2,     2,
       2,     2,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    65,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,     0,     0,     0,   360,
     663,   664,   665,   666,   667,   101,   101,   668,   669,   670,
      97,   671,     0,   673,   101,   104,   674,   675,   676,   101,
     104,   101,   104,   101,   104,   101,   104,   101,   104,     5,
     672,   104,   104,   247,   249,   248,     0,    66,    65,     0,
       0,    65,    67,    64,     0,     0,   220,     0,     0,     0,
       0,   246,   251,     0,   204,     0,     0,   188,   212,   184,
     184,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   234,   233,   236,     0,     0,    32,    31,    34,     0,
       0,     0,    53,    52,    51,    50,     0,     0,    91,     0,
     253,     0,    85,     0,     0,   281,   343,   347,   356,   353,
     289,   362,   350,     0,     0,   346,   360,   390,     0,     0,
       0,   348,   349,     0,     0,     0,   360,     0,   351,   352,
     357,   388,   389,     0,   387,   255,   102,     0,     0,    95,
      70,    75,   142,   438,   482,   605,   611,   642,     0,     0,
       0,     0,     0,    16,   146,     0,     0,     0,     0,     0,
     723,     0,     0,     0,     0,     0,     0,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,    16,   724,     0,     0,     0,    16,
       0,    16,   725,   485,     0,     0,   490,     0,     0,     0,
     726,     0,     0,     0,   640,     0,     0,     0,     0,     0,
       0,     0,     0,   727,     0,     0,   167,   171,     0,     0,
       0,     0,   728,     0,     0,     0,     0,    16,     0,    16,
       0,   721,     0,     0,     0,     0,    28,   722,     0,     0,
     149,   148,     0,     0,    67,    61,    62,     0,    68,     0,
     240,   238,     0,     0,     0,     0,   241,   160,   159,     0,
       0,   250,   252,   251,     0,   185,     0,   208,   180,   179,
       0,     0,   183,   184,   184,   596,   184,   184,     0,     0,
      17,    18,     0,     0,     0,   230,   231,   227,   225,   226,
     228,   229,   237,     0,   239,     0,     0,    33,    35,     0,
       0,   129,     6,     8,   360,   130,    54,     0,    58,    92,
      93,    81,    82,    83,   140,     0,   270,    94,     0,    49,
       0,     0,   343,   362,   343,   360,   343,   343,     0,   335,
       0,   360,     0,     0,     0,   346,   346,     0,   385,   360,
     360,   360,   360,   360,     0,   306,   307,     0,   309,     0,
       0,   293,   291,   360,   290,   292,   315,   313,   314,   321,
       0,   326,   330,     0,   741,   736,   737,   738,   739,   363,
     740,   364,   365,   366,   367,   368,   369,   370,   743,   746,
     745,   742,   744,   747,   748,   749,   752,   750,   751,   753,
     754,   755,   756,   757,   758,   391,   392,   360,   360,   360,
     360,   360,   360,   360,   360,   360,   360,   360,   360,   360,
       0,     0,   729,   733,     0,   143,   107,   128,   115,     0,
     105,    12,    14,    13,    15,    11,   106,   131,   120,   270,
     121,     0,     0,   360,   109,   119,     0,   110,     0,   117,
     108,   144,   145,   439,     0,     0,     0,     0,     0,     0,
       0,    16,     0,     0,     0,    19,     0,     0,     0,   451,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
      16,     0,    16,     0,    16,     0,    16,     0,     0,    16,
      16,    16,     0,   440,   483,   491,   486,   489,   487,   484,
     493,   606,     0,     0,     0,   607,   612,     0,   131,     0,
     172,     0,   168,   627,   625,   626,     0,     0,     0,     0,
       0,     0,     0,   613,   620,   173,   643,    16,   648,     0,
     644,   658,     0,   657,     0,   661,     0,   659,   660,   647,
       0,    71,     0,    73,    16,   731,   732,   730,     0,    27,
       0,   735,   734,   154,   153,   155,   157,   158,   156,     0,
     151,   244,     0,    63,    69,    59,   221,   224,   242,   243,
     164,   165,     0,   162,   245,     0,   181,   186,   203,     0,
     210,   209,     0,     0,   187,   194,     0,     0,   202,   270,
     196,   195,   199,   200,     0,   201,   189,     0,   193,   211,
     219,   213,   216,   217,   215,   218,   214,   587,   587,     0,
     184,   587,   184,   587,   588,   662,     0,     0,    21,     0,
       0,   232,     0,     0,    30,    39,    40,    41,    42,    43,
      44,    45,    46,    47,     0,    37,    29,     0,     0,    56,
      57,   131,     0,    79,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,     0,     0,     0,   254,
     274,    89,    90,     0,     0,    84,    86,    48,     0,   270,
     339,   340,     0,   341,   342,   337,   325,   418,   421,     0,
     398,     0,   399,   344,   345,   338,     0,     0,     0,     0,
       0,     0,   308,   360,   371,   360,   302,   300,     0,     0,
     299,     0,     0,   354,   327,   328,     0,     0,   355,   383,
     381,   379,   376,   377,   378,   380,   382,   384,   372,   373,
     374,   375,   393,     0,   394,   396,   397,   103,     0,    98,
     116,   135,   138,   147,   275,   276,   118,   122,   112,    16,
     277,   113,   111,     0,     0,    16,   475,   477,     0,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   452,
       0,     0,     0,     0,     0,     0,   445,     0,   446,     0,
     473,     0,     0,     0,     0,     0,     0,     0,   457,   458,
       0,     0,     0,   479,     0,     0,     0,   609,   610,     0,
     638,   624,   615,     0,     0,   619,   614,   616,     0,   622,
     623,   621,     0,     0,     0,     0,     0,     0,   654,    19,
     656,     0,   651,   655,    78,    72,    74,    76,    23,    22,
      77,   150,     0,    60,   161,     0,   182,   207,   206,   205,
     191,   198,   192,   190,   197,   586,     0,     0,   595,   604,
       0,   602,     0,     0,   599,   597,     0,   587,     0,   587,
       0,    24,    25,     0,     0,    10,     9,    36,     0,     7,
      55,   141,    80,   269,   268,   270,   360,    87,    88,   279,
     272,     0,   282,   336,   360,   407,     0,   360,   360,   360,
     386,   360,   405,   360,     0,     0,   360,   360,   360,   289,
     316,   322,     0,     0,   331,   360,     0,   136,     0,   131,
       0,   127,   114,     0,     0,     0,   476,     0,   472,   466,
     441,     0,    20,     0,   447,     0,   450,     0,   453,   465,
     464,   459,     0,     0,   474,   462,   454,   455,   456,   478,
     480,   461,   460,   481,   463,   488,   578,    16,     0,    16,
     504,     0,     0,   506,   496,    16,   492,     0,   510,   579,
     608,   618,   636,   641,   166,   168,   617,     0,     0,     0,
       0,     0,   170,   645,   646,   653,    19,     0,   652,   152,
     163,   590,   589,   603,   598,   600,   601,     0,   591,     0,
     593,     0,     0,    38,   271,     0,   411,     0,   412,   413,
       0,   360,   409,   410,   408,   360,   360,     0,   360,     0,
       0,   360,   285,     0,   278,   419,   400,     0,     0,     0,
       0,     0,   360,   358,   301,   299,     0,     0,   305,     0,
       0,     0,   132,   133,   137,   139,   123,   124,   125,   126,
     468,     0,   470,   471,   442,     0,   449,   448,   467,   444,
     131,   509,   497,     0,     0,    16,     0,   495,     0,     0,
     513,   508,   512,     0,     0,   502,   494,     0,   520,   633,
     169,   173,    26,     0,     0,     0,     0,   649,   650,   592,
     594,   220,   220,   360,   360,   360,   360,     0,     0,     0,
     280,   286,     0,     0,   431,   414,   416,     0,   273,   404,
     402,   403,   401,   360,     0,   303,   360,     0,   395,     0,
     134,     0,   443,   579,   499,   500,   498,   501,   565,   534,
     514,   565,   503,   580,   521,     0,     0,   639,     0,   178,
     173,   173,   173,   173,     0,     0,     0,     0,     0,     0,
     425,   360,   332,   360,   360,     0,   360,   430,     0,   359,
       0,     0,     0,   329,     0,   469,   583,     0,     0,     0,
     523,   634,   628,   629,   630,   631,   632,   635,   637,   174,
     175,   176,   177,   222,   223,   424,   361,   428,     0,   360,
     422,   287,     0,     0,     0,     0,     0,     0,     0,     0,
     417,   406,   360,   312,   360,   310,     0,   581,   585,   505,
     568,   566,   569,    16,     0,    16,   511,     0,   507,     0,
       0,     0,     0,     0,     0,   519,   533,     0,     0,     0,
     360,   360,   294,   298,   296,   360,   432,   297,   319,   317,
     318,   323,     0,   427,   426,   360,   360,   360,   360,   433,
       0,     0,    96,     0,   570,     0,     0,   517,   518,   516,
     515,   527,   525,   524,     0,     0,   528,   530,   531,   532,
     522,   429,   288,   423,   334,   299,     0,   360,     0,     0,
       0,     0,     0,   360,   311,     0,     0,     0,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   584,   564,     0,   571,   567,   526,   529,   295,
     360,   320,   333,   324,     0,     0,     0,     0,     0,    16,
     572,   539,   554,   535,   538,   536,     0,   552,     0,   540,
     542,   543,   544,   545,   546,   547,   548,   549,   558,   559,
     560,    16,   537,     0,     0,    16,   582,     0,   437,   435,
     436,   434,   304,   555,     0,   551,   541,   553,   561,   562,
     563,   556,   550,     0,   557,   573,   574,   575,     0,   576,
     577
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   505,    81,   506,   362,   825,   889,   890,
     688,  1133,   620,    82,   377,   159,   380,   704,   705,    83,
     166,   167,    84,    19,    20,    21,    22,    23,    24,   122,
     329,    85,   312,    86,   318,   313,    87,   395,    88,   398,
     736,   390,    89,    90,   494,    91,    92,   207,   231,   514,
     971,   808,   498,    93,   801,  1094,   968,   802,   803,   711,
     712,    94,    95,   507,   232,   323,   629,   630,   340,   642,
     643,   295,   863,   296,   297,   875,    25,    26,    27,    28,
     358,    29,    30,    31,   350,   667,    32,   347,   653,    33,
     351,   333,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   153,   373,    45,    46,    47,    48,    49,
      50,    51,    52,    53,   116,   344,    96,   396,    97,   726,
     727,   728,   941,   805,   806,   515,   739,   730,    98,   401,
    1067,  1068,  1240,   198,   436,  1288,   767,   768,   437,  1087,
     769,   438,   439,  1291,   440,  1292,   199,   442,   443,  1242,
     407,   200,   408,   417,   201,   202,   203,  1070,   204,   475,
    1085,  1071,  1156,  1157,   748,   749,  1072,    99,   100,   101,
     102,   274,   275,   276,   855,  1017,  1118,  1123,  1121,  1122,
    1218,  1267,  1018,  1220,  1277,  1019,  1354,  1217,  1261,  1262,
    1306,  1404,  1415,  1416,  1417,  1110,  1128,  1303,  1258,  1111,
     906,    54,    55,    56,    57,    58,    59,    60,    61,   679,
     103,   104,   105,   106,   586,  1227,  1188,  1129,  1023,   578,
     579,   107,   108,   304,   882,   883,   305,    62,   109,    63,
     110,   111,   112,   476
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1178
static const yytype_int16 yypact[] =
{
     112,  2339,   109,   172,   473,   269,   117,   473,   473,    35,
     400,   473,   132,   840,    44,    68,   625,   620,   473, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178,   221,   372,   211,   575,
     289,   241, -1178, -1178,   315,   214,   219,    54,   349,  1312,
   -1178, -1178, -1178, -1178, -1178,   360,   360, -1178, -1178, -1178,
      43, -1178,   618, -1178,   360,  2124, -1178, -1178, -1178,   360,
    2056,   360,  1885,   360,  2030,   360,  1917,   360,  1831, -1178,
   -1178,   970,  1993, -1178, -1178, -1178,    19, -1178,   397,   425,
     435,   397,   371, -1178,   440,   448,   411,   473,   473,   491,
      38, -1178,   645,    79, -1178,   513,   522, -1178, -1178,   339,
     520,   461,   461,   545,   589,   614,   623,   644,   663,   685,
   -1178, -1178, -1178,   661,   690,   677, -1178,   694, -1178,   -15,
      19,   129, -1178, -1178, -1178, -1178,   105,   392,   631,   660,
   -1178,   740, -1178,   434,    38, -1178,    27, -1178, -1178, -1178,
     750,   445, -1178,   595,     6,     4,  1312, -1178,   452,   476,
     500, -1178, -1178,   501,   503,   504,  1126,    53, -1178, -1178,
   -1178, -1178, -1178,  1802, -1178,  2415,   741,   507,   510, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,   512,    19,
     822,   775,   129,   554, -1178,   737,    49,   764,   838,    38,
   -1178,   524,   528,   527,   383,   651,   856,   554,   786,   -61,
     760,    25,   461,   816,   680,   824,     1,   686,   682,   363,
     681,   678,   429,   669,   666,   554,   664,   665,   658,   -29,
     -43,   696,   655,   653,   554, -1178,   572,   574,   619,   554,
     129,   554, -1178, -1178,   578,   580, -1178,   587,   844,   403,
   -1178,   590,   593,   863, -1178,   917,   129,   600,   -64,   129,
     129,   877,   -21, -1178,   610,   612, -1178,   611,   613,   671,
     461,   878, -1178,   616,   834,   627,   890,   554,   899,   554,
     897, -1178,   632,   634,   636,   902,   955, -1178,   639,   646,
   -1178, -1178,   891,   980,   371, -1178, -1178,   982,   129,   985,
   -1178, -1178,   971,   988,   991,   994, -1178, -1178, -1178,   131,
     998, -1178, -1178,   695,   999, -1178,  1006,   412, -1178, -1178,
    2211,   553, -1178,   520,   520, -1178,   174,   210,  1007,  1009,
   -1178, -1178,    10,   883,   898, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178,  1010, -1178,   113,   973, -1178, -1178,  1580,
     679, -1178, -1178, -1178,  1312, -1178,   129,   673, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178,   688,  2343, -1178,   304, -1178,
     689,   704,    27, -1178,    27,  1312,    27,    27,  1001, -1178,
    1015,   723,  1005,   819,  1014,     4,     4,  1003,  1013,  1312,
    1312,  1312,  1312,  1312,  1023, -1178, -1178,  1018, -1178,   706,
      76, -1178, -1178,   747, -1178, -1178,  1042, -1178, -1178, -1178,
     108,    -4, -1178,   122, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178,  1312,  1312,  1312,
    1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,  1312,
     667,  1031, -1178, -1178,   -83, -1178, -1178, -1178, -1178,   619,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,  1067,
   -1178,   129,   954,  1312, -1178, -1178,   129, -1178,   129, -1178,
   -1178, -1178, -1178, -1178,   987,   995,  1011,   720,   725,   129,
     833,   554,   461,   129,   879,  1049,   129,  1021,   129, -1178,
     744,  1022,   881,   129,   129,   554,  1032,   766,  1027,   768,
     554,   769,   554,   254,   554,   822,   554,   771,   772,   554,
     554,   554,   774, -1178, -1178, -1178, -1178, -1178,  1024, -1178,
   -1178, -1178,  1099,   781,   782, -1178, -1178,   129, -1178,   783,
   -1178,   784,  1026, -1178, -1178, -1178,   785,   790,   793,   129,
     795,   796,   797, -1178, -1178,    67, -1178,   554, -1178,   822,
   -1178, -1178,   332, -1178,   461, -1178,   927, -1178, -1178, -1178,
     129, -1178,   129, -1178,   554, -1178, -1178, -1178,   129, -1178,
     461, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,   393,
   -1178, -1178,  1134, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178,   414, -1178, -1178,  1135, -1178, -1178, -1178,  1121,
   -1178, -1178,  1132,   461, -1178, -1178,  1137,  1141, -1178,  1067,
   -1178, -1178, -1178, -1178,   461, -1178, -1178,  1142, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178,  1131,  1131,   626,
     520,  1131,   520,  1131, -1178, -1178,   129,   461, -1178,  1139,
    1147, -1178,   825,   826, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178,   464, -1178, -1178,  1432,  1145, -1178,
   -1178, -1178,   832, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178,    48,   835,   836, -1178,
   -1178, -1178, -1178,   461,   129, -1178, -1178, -1178,  2187,  2343,
   -1178, -1178,  1466, -1178, -1178, -1178, -1178,   245, -1178,   837,
   -1178,  1150, -1178, -1178, -1178, -1178,   449,   479,   509,  1506,
     535,   -99, -1178,  1312, -1178,  1312, -1178,  1165,   847,   848,
    1432,   217,   276, -1178, -1178, -1178,  1163,  1161, -1178,  1925,
    1925,  1925,  2467,  2467,  1925,  1925,  1925,  1925,   542,   542,
    1013,  1013, -1178,   846, -1178, -1178, -1178, -1178,   461, -1178,
   -1178,  1153, -1178,   849, -1178, -1178, -1178,  1093, -1178,   554,
    2415, -1178, -1178,   129,   129,   554, -1178, -1178,   855,   554,
     857,   859,   866,   129,  1175,  1019,   867,   129,   870, -1178,
     129,   873,   893,   901,   903,   129, -1178,   619, -1178,   905,
   -1178,   912,   913,   914,   915,   921,   923,   924, -1178, -1178,
     925,   930,   931, -1178,   129,  1209,   939, -1178, -1178,   940,
     226, -1178, -1178,   874,   941, -1178, -1178, -1178,   944, -1178,
   -1178, -1178,   129,   367,   550,   942,   946,   956, -1178,  1049,
   -1178,   461,   964,   927, -1178, -1178, -1178, -1178,    10, -1178,
   -1178, -1178,   891, -1178, -1178,   131, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178,  1237,  1293, -1178, -1178,
     619, -1178,   619,  1282, -1178, -1178,   619,  1131,  1295,  1131,
    1296, -1178, -1178,  1104,  1105, -1178, -1178, -1178,  1580, -1178,
   -1178,   849, -1178, -1178, -1178,  2343,   128, -1178, -1178, -1178,
     974,   972, -1178, -1178,  1312, -1178,  1281,  1312,  1312,  1312,
   -1178,  1312, -1178,  1312,   571,  1531,  1312,   767,  1312, -1178,
   -1178, -1178,   975,   750, -1178,  1312,  1197, -1178,   591, -1178,
     650, -1178, -1178,   976,   977,   983, -1178,   997, -1178, -1178,
   -1178,  1002, -1178,   129, -1178,  1004, -1178,  1016, -1178, -1178,
   -1178, -1178,  1017,  1036, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178,   554,   181,   229,
   -1178,  1029,   461, -1178, -1178,    60, -1178,  1038, -1178,  1030,
   -1178, -1178, -1178, -1178, -1178,  1026, -1178,  1039,  1306,  1306,
    1306,  1306, -1178, -1178, -1178, -1178,  1049,   129,   964, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178,  1330, -1178,  1333,
   -1178,  1329,  1337, -1178, -1178,    -5, -1178,  1323, -1178, -1178,
    1020,  1312, -1178, -1178, -1178,  1312,  1312,  1012,    12,  1802,
    1040,  1183, -1178,  2343, -1178, -1178, -1178,  1558,  1583,  1608,
    1635,   596,  1312, -1178, -1178,  2415,  1043,  1041,  2415,  1344,
    1660,  1345,   461, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178,   129, -1178, -1178, -1178,  1044, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178,   129,   129,   554,   129, -1178,  1045,   619,
   -1178, -1178,  1047,  1051,   129, -1178, -1178,   129,  1055,   -37,
   -1178,    67, -1178,  1046,  1058,  1059,  1060, -1178, -1178, -1178,
   -1178,   411,   411,  1312,   723,  1312, -1178,   791,  2350,   697,
   -1178, -1178,  1367,   253, -1178,  2415,  1063,  1062, -1178, -1178,
   -1178, -1178, -1178,  1312,  1685,  1394,  1229,  1061, -1178,  1204,
   -1178,  1069, -1178,  -215, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178,   129,   523, -1178,  1070, -1178,
      67,    67,    67,    67,  1406,  1407,   996,  1074,  1263,  1866,
   -1178,   160, -1178,  1312,  1312,   556,  1183, -1178,  1711, -1178,
    1081,  1082,     8, -1178,  1405, -1178,  1083,    31,    33,    34,
     539, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,  1087,   128,
    1262, -1178,    20,  1339,  1404,  1101,  1102,  1103,  1109,  1097,
   -1178, -1178,  1312, -1178,  1312, -1178,  1108, -1178, -1178, -1178,
   -1178, -1178,    87,   554,   129,   554, -1178,  1110, -1178,   129,
     129,   129,  1230,    61,   -40, -1178, -1178,  1111,  1112,  1122,
     160,    45, -1178, -1178, -1178,   747, -1178, -1178,  1444, -1178,
   -1178, -1178,   302, -1178, -1178,  1312,  1312,  1312,  1312, -1178,
    1123,  1129, -1178,  2120, -1178,   129,  1130, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178,   129,   129, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178,  1736,    95,    45,   173,  1762,
    1787,  1812,  1837,  1312, -1178,  1176,  1140,   129,   554,   129,
     129,   129,  1252,   129,   127,   794,    18,  1195,   129,  1179,
    1178,  1207, -1178, -1178,  1144, -1178, -1178, -1178, -1178, -1178,
    1312, -1178, -1178, -1178,  1146,  1158,  1162,  1164,  1148,   554,
   -1178, -1178, -1178, -1178, -1178, -1178,   129, -1178,   129, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178,   554, -1178,   100,   129,   554, -1178,  1736, -1178, -1178,
   -1178, -1178, -1178, -1178,    16, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178,  -162, -1178, -1178, -1178, -1178,  1168, -1178,
   -1178
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1178, -1178, -1178,  -156, -1178,  -115,  -235,  -832,  -139,  -650,
   -1178,  -319, -1178, -1178, -1178, -1178, -1178, -1178,   555, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,   394,
    1185, -1178, -1178, -1178, -1178, -1178, -1178,  -260, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178,  1287,   990,  1277,
   -1178,   165,  -371, -1178, -1178, -1178, -1178,   541,  -568, -1178,
   -1178, -1178, -1178, -1178, -1178,   -42, -1178,   621,   -91, -1178,
     628, -1164,   495,  -570, -1178,  -501, -1178, -1178, -1178, -1178,
    -131, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178,  -311, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178,   662,  1181, -1178, -1178, -1178, -1178,
    -727,   601,   453,  1149,   885,  1172, -1178,   798, -1178, -1178,
   -1158, -1178,   266,  -196,   754,   222,  -943,   592, -1177, -1037,
    1351, -1121,   779,   224, -1178, -1178,  -193,   787, -1178, -1178,
   -1178, -1178,   148,   417, -1178, -1178,  -915, -1178,   120,   492,
     -79, -1178, -1178,   356,   630,   427,  -866, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178,   391, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178,   402, -1178, -1178, -1178,
    -526, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1178,   693, -1178, -1178, -1178, -1178, -1178,
   -1178, -1178, -1178, -1012
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -421
static const yytype_int16 yytable[] =
{
     205,   435,   363,   364,   441,   385,   534,   535,   565,   359,
     860,   940,   864,  1084,   903,  1254,   382,  1143,  -284,   415,
     383,  1069,   774,   775,   583,   378,  1281,  -284,  -284,  -284,
    -284,  1055,   798,   413,  1413,  1282,  1283,  1284,   959,   686,
     557,   434,   402,   360,   361,   555,   403,  1035,  1317,   360,
     361,  -283,   360,   361,   320,   404,  1276,  1153,  1056,   321,
    -283,  -283,  -283,  -283,  1055,  1289,   500,   933,   382,   431,
     432,   180,   383,   337,   173,   382,   382,   530,   338,   383,
     383,  1279,   345,   400,   477,   478,   479,   480,   481,   508,
     540,  1056,  1127,  1057,   501,   502,   503,   504,   482,   483,
     484,   485,   486,   487,   488,   489,  1388,   418,   490,    64,
    1282,  1283,  1284,   959,   567,   382,     1,   430,   381,   383,
     123,  1290,   528,  1324,  1418,   386,  1057,   969,   382,  1212,
     581,   692,   383,   587,   588,   131,   509,   510,   520,  1353,
     551,   516,   382,   931,   382,   872,   383,  1055,   383,   562,
     126,  1289,   907,  1069,   566,   918,   568,   920,   387,   141,
     174,   598,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1362,
    1263,  1315,   634,   531,  1056,    65,  1419,   496,  1185,  1055,
     590,   873,  1065,   142,   846,  1066,   556,  1238,  1282,  1283,
    1284,   959,   611,   352,   613,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1151,   414,  1137,    66,  1056,  1290,   558,  1057,
      67,   666,   934,    68,   680,  1065,   346,  1301,  1066,   693,
     640,   874,   677,   678,    69,   681,   683,   533,   877,   352,
     708,  1199,   382,   431,   432,   959,   383,  1378,   952,   800,
     155,  1057,  1318,   953,   382,  1319,    70,   513,   383,    71,
     682,    72,    73,   477,   478,   479,   480,   481,   799,    74,
     584,   585,   641,   501,   502,   503,   504,   482,   483,   484,
     485,   486,   487,   488,   489,  1204,  1186,   490,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1205,  1069,    75,   171,   117,
      76,   382,   431,   432,   959,   383,   409,   821,  1065,  1264,
    1389,  1066,    77,  1390,  1187,   707,   591,   592,   168,  1300,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,   160,  1093,   169,
     118,    78,  1265,   161,  1069,   379,   742,   119,   120,   121,
    1065,  1144,   747,  1066,   170,  1241,   776,   384,   172,   539,
     756,   757,   758,   759,   760,  1255,   940,   416,  -284,   687,
     360,   361,   878,  -284,   770,   807,  1285,  1414,   352,   322,
     807,  1286,   807,   405,  1124,  1069,  1069,   879,   175,   880,
     406,    79,  1259,   818,  1266,  1268,  1304,   822,   339,   206,
     826,  -283,   828,   209,  1305,   888,  -283,   832,   833,   433,
    1368,  1047,   156,  1049,  1408,  1409,   384,   384,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   157,  1069,   764,  1241,   648,   820,   117,   765,   113,
     114,   859,   158,   353,   731,   732,   733,   734,   325,   888,
     834,  1360,   328,   868,   810,   839,   384,   841,   326,   845,
     115,   847,  1170,   330,   850,   851,   852,  1113,  1114,   384,
     772,   331,   922,   773,   884,   864,   885,   477,   478,   479,
     480,   481,   887,   384,   777,   384,   842,   778,  1028,  -283,
    1029,   482,   483,   484,   485,   486,   487,   488,   489,   360,
     361,   490,   876,  1115,   354,   332,   649,   477,   478,   479,
     480,   481,   113,   114,   336,  1116,   843,   844,   937,   886,
    1239,   482,   483,   484,   485,   486,   487,   488,   489,  1285,
      80,   490,   324,   115,   899,   327,   348,   477,   478,   479,
     480,   481,   409,   650,   409,   349,   409,   409,   127,   128,
     921,   482,   483,   484,   485,   486,   487,   488,   489,   352,
     651,   490,  1173,   477,   478,   479,   480,   481,   365,   917,
     740,   919,   741,   384,   743,   744,   669,   482,   483,   484,
     485,   486,   487,   488,   489,   384,  1022,   490,   969,   382,
     488,   489,   670,   383,   490,   435,   435,   993,   938,   477,
     478,   479,   480,   481,   441,   543,   544,   944,   501,   502,
     503,   504,   366,   482,   483,   484,   485,   486,   487,   488,
     489,   524,   525,   490,   477,   478,   479,   480,   481,   360,
     361,  1092,   433,   162,   652,   434,   434,   367,   482,   483,
     484,   485,   486,   487,   488,   489,   368,   671,   490,   908,
    1189,   163,   672,   673,   391,   150,   392,   393,   355,   285,
     674,  1327,   735,  1245,  1328,   909,  1036,   369,   356,   357,
    1043,  1030,  1044,  1031,   164,   151,  1046,   973,   974,   966,
     152,   547,   548,   287,   341,   342,   370,   981,   675,   124,
     125,   985,   129,   130,   987,   391,   372,   392,   393,   992,
     154,   811,   210,   812,   954,   343,   955,   211,   371,  1229,
    1230,  1231,  1232,   374,   972,   143,  1246,  1247,  1005,   375,
     975,   212,   676,   910,   977,   477,   478,   479,   480,   481,
    1134,  1135,  1136,   165,   341,   342,  1027,   573,   574,   482,
     483,   484,   485,   486,   487,   488,   489,   709,   710,   490,
     388,   144,   145,   888,   891,   892,   176,   213,   177,   178,
     179,   180,   181,   182,  1096,  1097,  1098,  1099,  1248,   183,
     184,   376,   185,  1249,   186,   894,   895,   389,  1269,   397,
     176,   394,   177,   178,   179,   180,   181,   182,   146,   147,
     148,   149,   399,   183,   184,   766,   185,   508,   186,   410,
     176,   411,   177,   178,   179,   180,   181,   182,   419,   334,
     335,   947,   412,   183,   184,   766,   185,  1222,   186,   477,
     478,   479,   480,   481,   187,   927,   928,  1270,  1271,  1272,
     188,  1273,   420,   482,   483,   484,   485,   486,   487,   488,
     489,   948,  1274,   490,   509,   510,   792,  1105,   187,   511,
    1194,  1195,   753,   754,   188,   512,   421,   422,   911,   423,
     424,   497,   491,  1223,  1224,  1225,  1226,   492,   187,   793,
     493,   949,   495,   499,   188,   794,   518,   888,   519,  1179,
     795,   796,   521,   189,   190,   747,   522,   523,  1077,  1078,
    1079,   526,  1080,  1120,  1081,   214,   527,   951,   529,  1088,
    1275,  1138,   532,   536,   912,   537,  1090,   189,   190,   541,
     384,   538,  1112,   542,  1117,   546,   545,   191,   192,   913,
    1125,   549,   550,   552,   554,   561,   553,   189,   190,   560,
     563,   559,   193,  1082,   564,   194,   569,   914,   572,   195,
     570,   191,   192,   425,   426,   427,   428,   571,   575,   215,
     577,   915,   916,   576,   216,   513,   193,   580,  1163,   194,
     582,   191,   192,   195,   589,  1171,   132,   133,   593,   217,
     594,   595,   599,   596,   600,   134,   193,  1174,  1175,   194,
    1177,   623,   597,   195,   610,   609,   612,   614,  1182,   618,
     615,  1183,   616,   135,   617,   619,   136,   621,   137,   138,
     624,   625,  1147,   631,   622,   633,  1148,  1149,   635,   601,
     636,   637,  1155,   694,   638,   626,   627,   639,   628,   689,
    1176,   644,   646,  1164,   477,   478,   479,   480,   481,   647,
     684,   219,   685,   691,   690,   745,   751,   706,   482,   483,
     484,   485,   486,   487,   488,   489,   713,   737,   490,  1221,
     746,   750,   755,   762,   306,   307,   308,  1202,   309,   310,
     738,   752,   761,   602,   220,   490,  1287,   221,   763,   771,
     797,   222,   223,   809,   813,   225,   226,   815,   816,   196,
    -420,   227,   814,   817,  1196,   747,  1198,   197,  1380,  1381,
    1382,  1383,  1384,  1385,  1386,  1387,   603,   819,  1260,   824,
    1260,   823,   829,   196,  1208,   604,   804,  1088,   827,   830,
     266,   197,   273,   831,   281,   228,   294,   139,   303,   835,
     229,   314,   319,   196,   836,   837,   838,   840,  1308,   848,
     849,   197,   853,  1311,  1312,  1313,   854,  1316,   856,   857,
     858,   861,   862,   865,  1243,  1244,   285,  1155,   866,  1200,
    1287,   867,  1287,   869,   870,   871,   881,   893,   896,   176,
     897,   177,   178,   179,   180,   181,   182,   898,  1307,  1355,
    1309,   905,   183,   184,   923,   185,   900,   186,  1357,  1358,
     901,   904,   924,   925,   926,   930,   605,   606,   607,   608,
     932,   140,   956,   935,   945,  1088,   936,   946,   962,   963,
     967,  1371,   965,  1373,  1374,  1375,   970,  1377,  1379,   957,
     958,   969,  1392,   976,   982,   978,   176,   979,   177,   178,
     179,   180,   181,   182,   980,   984,  1325,   187,   986,   183,
     184,   988,   185,   188,   186,  1024,  1329,  1330,  1331,  1332,
    1405,   983,  1406,  1372,   714,   715,   716,   717,   718,   719,
     720,   989,   721,   722,   723,   724,   725,  1410,  1411,   990,
    1041,   991,   176,   994,   177,   178,   179,   180,   181,   182,
     995,   996,   997,   998,  1403,   183,   184,  1211,   185,   999,
     186,  1000,  1001,  1002,   187,  1037,   189,   190,  1003,  1004,
     188,   477,   478,   479,   480,   481,  1407,  1020,  1021,  1025,
    1412,  1397,  1026,  1032,  1033,   482,   483,   484,   485,   486,
     487,   488,   489,  1006,  1034,   490,  1042,  1045,  1048,  1050,
     191,   192,   425,   426,   427,   428,  1051,  1052,  1076,  1074,
     187,   311,  1073,  1091,  1100,   193,   188,  1089,   194,  1101,
    1119,  1102,   195,   189,   190,   176,  1132,   177,   178,   179,
     180,   181,   182,  1139,  1235,  1103,  1140,  1127,   183,   184,
    1104,   185,  1106,   186,  1141,  1145,  1007,   477,   478,   479,
     480,   481,  1142,  1150,  1107,  1108,  1146,   191,   192,  1167,
    1169,   482,   483,   484,   485,   486,   487,   488,   489,   189,
     190,   490,   193,   208,  1109,   194,  1126,  1131,  1154,   195,
    1165,   218,  1172,  1166,  1190,  1178,   233,  1180,   267,  1203,
     277,  1181,   282,   187,   298,  1184,  1191,  1192,  1193,   188,
    1207,  1210,  1213,   191,   192,  1206,  1214,  1215,  1228,  1233,
    1234,  1236,   477,   478,   479,   480,   481,  1252,   193,  1253,
    1256,   194,  1008,  1257,  1278,   195,   482,   483,   484,   485,
     486,   487,   488,   489,  1280,  1299,   490,  1295,  1296,  1297,
     477,   478,   479,   480,   481,  1298,  1302,  1314,  1310,  1320,
    1321,  1326,   189,   190,   482,   483,   484,   485,   486,   487,
     488,   489,   196,  1322,   490,  1333,  1334,  1369,  1356,  1376,
     197,  1391,  1393,  1009,   477,   478,   479,   480,   481,  1394,
    1370,  1395,  1396,  1053,  1398,  1402,   191,   192,   482,   483,
     484,   485,   486,   487,   488,   489,  1399,  1010,   490,  1011,
    1400,   193,  1401,   517,   194,  1012,  1420,  1013,   195,   632,
    1095,  1014,  1015,  1039,   477,   478,   479,   480,   481,   196,
    1130,  -415,   668,  1040,   645,   960,  1158,   197,   482,   483,
     484,   485,   486,   487,   488,   489,  1054,   942,   490,   477,
     478,   479,   480,   481,   902,   729,  1323,   429,  1361,  1086,
    1016,   961,  1363,   482,   483,   484,   485,   486,   487,   488,
     489,  1152,  1250,   490,   964,   196,   477,   478,   479,   480,
     481,  1197,  1219,   197,  1075,  1216,  1038,     0,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
     490,   477,   478,   479,   480,   481,     0,     0,     0,     0,
       0,  1237,     0,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,     0,     0,   490,   477,   478,   479,   480,
     481,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
     490,     0,     0,   477,   478,   479,   480,   481,   196,     0,
       0,     0,     0,     0,     0,     0,   197,   482,   483,   484,
     485,   486,   487,   488,   489,     0,     0,   490,   477,   478,
     479,   480,   481,     0,     0,     0,     0,  1293,     0,     0,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,   490,   477,   478,   479,   480,   481,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   482,   483,   484,
     485,   486,   487,   488,   489,     0,     0,   490,     0,   477,
     478,   479,   480,   481,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   482,   483,   484,   485,   486,   487,   488,
     489,     0,  1294,   490,   477,   478,   479,   480,   481,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,     0,     0,   490,   929,
     477,   478,   479,   480,   481,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,     0,     0,   490,   477,   478,   479,   480,   481,
       0,     0,     0,   943,     0,     0,     0,   444,     0,   482,
     483,   484,   485,   486,   487,   488,   489,     0,     0,   490,
     477,   478,   479,   480,   481,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   950,   490,   477,   478,   479,   480,   481,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   482,
     483,   484,   485,   486,   487,   488,   489,     0,  1083,   490,
       0,   444,   219,   445,   446,     0,     0,   447,   448,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   299,     0,     0,     0,  1159,     0,     0,     0,     0,
       0,     0,     0,   449,     0,   220,     0,     0,   221,     0,
       0,     0,   222,   223,     0,     0,   225,   226,     0,     0,
    1160,     0,   227,     0,     0,     0,   219,     0,     0,     0,
       0,     0,     0,  -421,  -421,  -421,   450,   445,   446,     0,
       0,   447,   448,     0,     0,  1161,     0,  -421,  -421,  -421,
    -421,   486,   487,   488,   489,     0,   228,   490,   219,   220,
       0,   229,   221,     0,     0,     0,   222,   223,     0,   300,
     225,   226,  1162,     0,     0,     0,   227,     0,   283,     0,
       0,     0,   451,   452,     0,   453,   454,   455,   456,   457,
       0,   220,     0,     0,   221,     0,     0,  1168,   222,   223,
     450,   284,   225,   226,     0,     0,     0,     0,   227,     0,
     228,     0,     0,     0,     0,   229,     0,   285,     0,     0,
       0,     0,  1209,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   219,     0,     0,     0,     0,     0,
     286,   287,   228,     0,     0,     0,     0,   229,  1251,   467,
     468,     0,     0,     0,     0,     0,     0,     0,     0,   315,
       0,   469,   470,   471,   472,     0,     0,   220,     0,     0,
     221,   219,     0,  1359,   222,   223,     0,     0,   225,   226,
     301,     0,     0,     0,   227,     0,     0,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,   219,     0,  1364,
       0,   316,   234,     0,   220,     0,     0,   221,     0,     0,
       0,   222,   223,   467,   468,   225,   226,     0,   228,     0,
       0,   227,     0,   229,  1365,   469,   470,   471,   472,     0,
     220,   473,   474,   221,     0,     0,     0,   222,   223,     0,
       0,   225,   226,   268,     0,     0,     0,   227,   269,  1366,
     270,     0,     0,   235,     0,   228,   236,     0,   237,     0,
     229,     0,     0,     0,     0,   219,     0,     0,     0,     0,
       0,     0,   302,     0,  1367,     0,     0,     0,     0,     0,
    1335,   228,     0,     0,     0,   271,   229,     0,     0,     0,
       0,     0,     0,     0,   238,   473,   474,     0,   220,     0,
     288,   221,     0,     0,   239,   222,   223,     0,   224,   225,
     226,     0,     0,     0,   654,   227,     0,     0,     0,     0,
     285,     0,     0,     0,     0,     0,   272,     0,     0,   360,
     361,     0,     0,     0,   289,   290,   291,     0,     0,     0,
     240,     0,     0,   292,   287,     0,     0,     0,     0,   228,
       0,   655,     0,     0,   229,     0,   241,   242,   293,   243,
     244,     0,   245,   246,   247,  1336,   248,     0,     0,   249,
     250,     0,   251,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   656,   252,   253,     0,     0,
     657,   254,     0,   255,   256,     0,   257,   658,   659,     0,
       0,   258,     0,     0,     0,   259,   260,     0,   261,   262,
     660,   263,   264,     0,     0,     0,     0,     0,     0,   661,
     662,   663,   664,     0,   665,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   317,     0,     0,     0,     0,  1337,
       0,     0,   278,   279,   714,   715,   716,   717,   718,   719,
     720,     0,   721,   722,   723,   724,   725,     0,   477,   478,
     479,   480,   481,     0,     0,     0,     0,     0,     0,     0,
       0,   280,   482,   483,   484,   485,   486,   487,   488,   489,
       4,     0,   490,     0,  1338,     0,  1339,     0,  1340,  1341,
    1342,  1343,  1344,  1345,     0,     0,     0,   265,     0,     0,
       0,     5,     6,  1346,  1347,     0,     0,  1348,     0,   513,
       0,     0,  1349,     0,     0,     0,     0,     0,     0,     0,
    1350,     0,     0,   477,   478,   479,   480,   481,  1351,     0,
       0,     0,     0,     0,     0,     7,     8,   482,   483,   484,
     485,   486,   487,   488,   489,     0,     0,   490,     0,     0,
       0,     0,     0,     0,     0,     0,     9,     0,     0,     0,
       0,  1352,     0,     0,     0,   230,    10,     0,     0,    11,
       0,    12,     0,     0,    13,   477,   478,   479,     0,    14,
      15,    16,     0,     0,     0,     0,    17,    18,     0,   482,
     483,   484,   485,   486,   487,   488,   489,     0,     0,   490,
     714,   715,   716,   717,   718,   719,   720,     0,   721,   722,
     723,   724,   725,     0,     0,     0,     0,     0,     0,     0,
       0,  1201,     0,     0,   939
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1178))

#define yytable_value_is_error(yytable_value) \
  ((yytable_value) == (-421))

static const yytype_int16 yycheck[] =
{
      79,   197,   141,   142,   197,   161,   241,   242,   268,   140,
     578,   738,   582,   956,   664,     7,    15,    22,     6,    15,
      19,   936,    26,    27,    88,    40,     6,    15,    16,    17,
      18,    19,   115,    27,    18,    15,    16,    17,    18,    29,
      83,   197,    15,    18,    19,    74,    19,   879,    88,    18,
      19,     6,    18,    19,    35,    28,  1220,  1069,    46,    40,
      15,    16,    17,    18,    19,  1242,   222,    19,    15,    16,
      17,    18,    19,    35,    20,    15,    15,   138,    40,    19,
      19,  1239,     3,   174,     8,     9,    10,    11,    12,    40,
     246,    46,   307,    81,    34,    35,    36,    37,    22,    23,
      24,    25,    26,    27,    28,    29,    88,   186,    32,     0,
      15,    16,    17,    18,   270,    15,     4,   196,   160,    19,
       3,  1242,   237,  1281,   286,    20,    81,   342,    15,  1166,
     286,    18,    19,   289,   290,     3,    87,    88,   229,  1303,
     255,    92,    15,   711,    15,    78,    19,    19,    19,   264,
     115,  1328,   678,  1068,   269,   681,   271,   683,    53,   115,
     106,   300,   150,   151,   152,   153,   154,   155,   156,  1327,
     137,   110,   328,   234,    46,     3,   338,   219,   215,    19,
     201,   114,   170,   115,   555,   173,   215,  1199,    15,    16,
      17,    18,   307,    19,   309,   150,   151,   152,   153,   154,
     155,   156,  1068,   197,  1036,    33,    46,  1328,   251,    81,
      38,   350,   164,    41,    40,   170,   137,  1254,   173,   375,
      89,   154,   353,   354,    52,   356,   357,   202,   599,    19,
     386,  1146,    15,    16,    17,    18,    19,   110,   337,   499,
      19,    81,   282,   342,    15,   285,    74,   198,    19,    77,
      40,    79,    80,     8,     9,    10,    11,    12,   341,    87,
     324,   325,   131,    34,    35,    36,    37,    22,    23,    24,
      25,    26,    27,    28,    29,    22,   313,    32,   150,   151,
     152,   153,   154,   155,   156,    32,  1201,   115,    74,    20,
     118,    15,    16,    17,    18,    19,   176,   532,   170,   266,
     282,   173,   130,   285,   341,   384,   327,   328,    19,  1252,
     150,   151,   152,   153,   154,   155,   156,   106,   968,    78,
      51,   149,   289,   112,  1239,   340,   405,    58,    59,    60,
     170,   336,   411,   173,    19,  1201,   340,   336,   119,   338,
     419,   420,   421,   422,   423,   337,  1073,   343,   336,   339,
      18,    19,    20,   341,   433,   511,   336,   341,    19,   340,
     516,   341,   518,   336,   304,  1280,  1281,   602,    19,   604,
     343,   199,   341,   529,   341,   341,   289,   533,   340,    19,
     536,   336,   538,   340,   297,   620,   341,   543,   544,   336,
    1333,   917,    20,   919,   294,   295,   336,   336,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,    39,  1327,   337,  1280,     3,   531,    20,   342,    19,
      20,   577,    50,    84,   120,   121,   122,   123,     3,   664,
     545,   336,    61,   589,   513,   550,   336,   552,     3,   554,
      40,   556,  1092,     3,   559,   560,   561,   266,   267,   336,
     342,     3,   687,   345,   610,  1025,   612,     8,     9,    10,
      11,    12,   618,   336,   342,   336,   212,   345,   101,   341,
     103,    22,    23,    24,    25,    26,    27,    28,    29,    18,
      19,    32,   597,   302,   145,    74,    74,     8,     9,    10,
      11,    12,    19,    20,     3,   266,   242,   243,   733,   614,
     340,    22,    23,    24,    25,    26,    27,    28,    29,   336,
     338,    32,   118,    40,   653,   121,     3,     8,     9,    10,
      11,    12,   402,   111,   404,     3,   406,   407,   128,   129,
     686,    22,    23,    24,    25,    26,    27,    28,    29,    19,
     128,    32,  1110,     8,     9,    10,    11,    12,     3,   680,
     402,   682,   404,   336,   406,   407,     3,    22,    23,    24,
      25,    26,    27,    28,    29,   336,   340,    32,   342,    15,
      28,    29,    19,    19,    32,   771,   772,   837,   734,     8,
       9,    10,    11,    12,   777,   222,   223,   342,    34,    35,
      36,    37,     3,    22,    23,    24,    25,    26,    27,    28,
      29,   218,   219,    32,     8,     9,    10,    11,    12,    18,
      19,    20,   336,    38,   202,   771,   772,     3,    22,    23,
      24,    25,    26,    27,    28,    29,     3,    74,    32,     3,
    1131,    56,    79,    80,    15,    15,    17,    18,   299,   100,
      87,   339,   338,    87,   342,    19,   881,     3,   309,   310,
     910,   101,   912,   103,    79,    35,   916,   813,   814,   798,
      40,   232,   233,   124,    19,    20,     3,   823,   115,     7,
       8,   827,    10,    11,   830,    15,    15,    17,    18,   835,
      18,   516,    64,   518,   763,    40,   765,    69,     3,  1190,
    1191,  1192,  1193,     3,   809,    70,   140,   141,   854,    22,
     815,    83,   149,    77,   819,     8,     9,    10,    11,    12,
    1029,  1030,  1031,   138,    19,    20,   872,   314,   315,    22,
      23,    24,    25,    26,    27,    28,    29,    54,    55,    32,
     338,   106,   107,   968,   341,   342,    13,   119,    15,    16,
      17,    18,    19,    20,    94,    95,    96,    97,   192,    26,
      27,    57,    29,   197,    31,   341,   342,   126,   219,    19,
      13,   101,    15,    16,    17,    18,    19,    20,   143,   144,
     145,   146,   338,    26,    27,    28,    29,    40,    31,    29,
      13,   336,    15,    16,    17,    18,    19,    20,   336,   127,
     128,   342,   197,    26,    27,    28,    29,   274,    31,     8,
       9,    10,    11,    12,    81,   341,   342,   268,   269,   270,
      87,   272,   336,    22,    23,    24,    25,    26,    27,    28,
      29,   342,   283,    32,    87,    88,   159,   983,    81,    92,
    1141,  1142,   415,   416,    87,    98,   336,   336,   212,   336,
     336,    19,   101,   320,   321,   322,   323,   340,    81,   182,
     340,   342,   340,    78,    87,   188,    92,  1092,    20,  1119,
     193,   194,   338,   140,   141,   944,   338,   340,   947,   948,
     949,   220,   951,  1012,   953,   257,    20,   342,    92,   958,
     341,  1037,   122,    67,   258,   205,   965,   140,   141,   203,
     336,    67,  1007,   211,  1009,   217,   215,   174,   175,   273,
    1015,   232,   236,   239,   246,   252,   241,   140,   141,   254,
     338,   215,   189,   342,   340,   192,   338,   291,    74,   196,
     340,   174,   175,   176,   177,   178,   179,   340,   338,   311,
      67,   305,   306,   340,   316,   198,   189,    20,   342,   192,
     340,   174,   175,   196,    67,  1101,   106,   107,   338,   331,
     338,   340,    74,   340,   338,   115,   189,  1113,  1114,   192,
    1116,    70,   291,   196,    74,   338,    67,    70,  1124,    67,
     338,  1127,   338,   133,   338,    20,   136,   338,   138,   139,
      89,    90,  1061,     3,   338,     3,  1065,  1066,     3,   155,
      19,     3,  1071,    20,     3,   104,   105,     3,   107,   116,
    1115,     3,     3,  1082,     8,     9,    10,    11,    12,     3,
       3,    41,     3,     3,   116,    14,   197,   338,    22,    23,
      24,    25,    26,    27,    28,    29,   338,   338,    32,  1185,
      15,    26,    29,    15,    64,    65,    66,   340,    68,    69,
     336,    27,    19,   209,    74,    32,  1242,    77,   342,     7,
      19,    81,    82,    99,    67,    85,    86,    46,   338,   336,
     337,    91,    67,   338,  1143,  1144,  1145,   344,   274,   275,
     276,   277,   278,   279,   280,   281,   242,   244,  1217,    30,
    1219,   202,   338,   336,  1163,   251,    19,  1166,    67,    67,
     100,   344,   102,   212,   104,   125,   106,   257,   108,    67,
     130,   111,   112,   336,   338,    78,   338,   338,  1264,   338,
     338,   344,   338,  1269,  1270,  1271,    92,  1273,    19,   338,
     338,   338,   338,   338,  1203,  1204,   100,  1206,   338,   338,
    1326,   338,  1328,   338,   338,   338,   209,     3,     3,    13,
      19,    15,    16,    17,    18,    19,    20,    15,  1263,  1305,
    1265,    20,    26,    27,    15,    29,    19,    31,  1314,  1315,
      19,    19,    15,   338,   338,    20,   332,   333,   334,   335,
     338,   331,     7,   338,   337,  1254,   340,    27,    15,    18,
      27,  1337,   336,  1339,  1340,  1341,    93,  1343,  1344,   342,
     342,   342,  1348,   338,    19,   338,    13,   338,    15,    16,
      17,    18,    19,    20,   338,   338,  1285,    81,   338,    26,
      27,   338,    29,    87,    31,   341,  1295,  1296,  1297,  1298,
    1376,   202,  1378,  1338,   157,   158,   159,   160,   161,   162,
     163,   338,   165,   166,   167,   168,   169,  1393,  1394,   338,
       3,   338,    13,   338,    15,    16,    17,    18,    19,    20,
     338,   338,   338,   338,  1369,    26,    27,    28,    29,   338,
      31,   338,   338,   338,    81,   301,   140,   141,   338,   338,
      87,     8,     9,    10,    11,    12,  1391,   338,   338,   338,
    1395,  1360,   338,   341,   338,    22,    23,    24,    25,    26,
      27,    28,    29,    84,   338,    32,     3,    15,     3,     3,
     174,   175,   176,   177,   178,   179,   202,   202,    27,   337,
      81,   341,   338,   116,   338,   189,    87,   342,   192,   342,
     291,   338,   196,   140,   141,    13,    20,    15,    16,    17,
      18,    19,    20,     3,   338,   338,     3,   307,    26,    27,
     338,    29,   338,    31,    15,    22,   137,     8,     9,    10,
      11,    12,    15,   341,   338,   338,   336,   174,   175,    15,
      15,    22,    23,    24,    25,    26,    27,    28,    29,   140,
     141,    32,   189,    86,   338,   192,   338,   338,   338,   196,
     337,    94,   338,   342,   338,   340,    99,   340,   101,    22,
     103,   340,   105,    81,   107,   340,   338,   338,   338,    87,
     338,     7,   341,   174,   175,   342,   202,   338,   338,     3,
       3,   337,     8,     9,    10,    11,    12,   336,   189,   337,
      15,   192,   213,   340,   337,   196,    22,    23,    24,    25,
      26,    27,    28,    29,   172,   338,    32,   336,   336,   336,
       8,     9,    10,    11,    12,   336,   338,   217,   338,   338,
     338,     7,   140,   141,    22,    23,    24,    25,    26,    27,
      28,    29,   336,   341,    32,   342,   337,   291,   338,   217,
     344,   276,   293,   264,     8,     9,    10,    11,    12,   301,
     340,   274,   338,   928,   338,   337,   174,   175,    22,    23,
      24,    25,    26,    27,    28,    29,   338,   288,    32,   290,
     338,   189,   338,   226,   192,   296,   338,   298,   196,   324,
     969,   302,   303,   892,     8,     9,    10,    11,    12,   336,
    1025,   338,   350,   895,   343,   771,  1073,   344,    22,    23,
      24,    25,    26,    27,    28,    29,   935,   739,    32,     8,
       9,    10,    11,    12,   659,   396,  1280,   196,  1326,   957,
     341,   772,  1328,    22,    23,    24,    25,    26,    27,    28,
      29,  1069,  1206,    32,   777,   336,     8,     9,    10,    11,
      12,  1144,  1181,   344,   944,  1173,   883,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,   338,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,     8,     9,    10,    11,    12,   336,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   344,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,   338,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,   338,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,   337,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,   337,    -1,    -1,    -1,     5,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,   337,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,   337,    32,
      -1,     5,    41,    71,    72,    -1,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    -1,    -1,    -1,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,    -1,    74,    -1,    -1,    77,    -1,
      -1,    -1,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
     337,    -1,    91,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,   134,    71,    72,    -1,
      -1,    75,    76,    -1,    -1,   337,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,   125,    32,    41,    74,
      -1,   130,    77,    -1,    -1,    -1,    81,    82,    -1,   138,
      85,    86,   337,    -1,    -1,    -1,    91,    -1,    61,    -1,
      -1,    -1,   180,   181,    -1,   183,   184,   185,   186,   187,
      -1,    74,    -1,    -1,    77,    -1,    -1,   337,    81,    82,
     134,    84,    85,    86,    -1,    -1,    -1,    -1,    91,    -1,
     125,    -1,    -1,    -1,    -1,   130,    -1,   100,    -1,    -1,
      -1,    -1,   337,   221,   222,   223,   224,   225,   226,   227,
     228,   229,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
     123,   124,   125,    -1,    -1,    -1,    -1,   130,   337,   247,
     248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,   259,   260,   261,   262,    -1,    -1,    74,    -1,    -1,
      77,    41,    -1,   337,    81,    82,    -1,    -1,    85,    86,
     249,    -1,    -1,    -1,    91,    -1,    -1,   221,   222,   223,
     224,   225,   226,   227,   228,   229,    -1,    41,    -1,   337,
      -1,   108,    46,    -1,    74,    -1,    -1,    77,    -1,    -1,
      -1,    81,    82,   247,   248,    85,    86,    -1,   125,    -1,
      -1,    91,    -1,   130,   337,   259,   260,   261,   262,    -1,
      74,   329,   330,    77,    -1,    -1,    -1,    81,    82,    -1,
      -1,    85,    86,   258,    -1,    -1,    -1,    91,   263,   337,
     265,    -1,    -1,    97,    -1,   125,   100,    -1,   102,    -1,
     130,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    -1,   341,    -1,   337,    -1,    -1,    -1,    -1,    -1,
      60,   125,    -1,    -1,    -1,   300,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   138,   329,   330,    -1,    74,    -1,
     283,    77,    -1,    -1,   148,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,     3,    91,    -1,    -1,    -1,    -1,
     100,    -1,    -1,    -1,    -1,    -1,   341,    -1,    -1,    18,
      19,    -1,    -1,    -1,   317,   318,   319,    -1,    -1,    -1,
     184,    -1,    -1,   326,   124,    -1,    -1,    -1,    -1,   125,
      -1,    40,    -1,    -1,   130,    -1,   200,   201,   341,   203,
     204,    -1,   206,   207,   208,   145,   210,    -1,    -1,   213,
     214,    -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    74,   230,   231,    -1,    -1,
      79,   235,    -1,   237,   238,    -1,   240,    86,    87,    -1,
      -1,   245,    -1,    -1,    -1,   249,   250,    -1,   252,   253,
      99,   255,   256,    -1,    -1,    -1,    -1,    -1,    -1,   108,
     109,   110,   111,    -1,   113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,   219,
      -1,    -1,   312,   313,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   341,    22,    23,    24,    25,    26,    27,    28,    29,
      41,    -1,    32,    -1,   264,    -1,   266,    -1,   268,   269,
     270,   271,   272,   273,    -1,    -1,    -1,   341,    -1,    -1,
      -1,    62,    63,   283,   284,    -1,    -1,   287,    -1,   198,
      -1,    -1,   292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     300,    -1,    -1,     8,     9,    10,    11,    12,   308,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    97,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,
      -1,   341,    -1,    -1,    -1,   341,   127,    -1,    -1,   130,
      -1,   132,    -1,    -1,   135,     8,     9,    10,    -1,   140,
     141,   142,    -1,    -1,    -1,    -1,   147,   148,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   171,    -1,    -1,   337
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   347,   348,    41,    62,    63,    96,    97,   117,
     127,   130,   132,   135,   140,   141,   142,   147,   148,   369,
     370,   371,   372,   373,   374,   422,   423,   424,   425,   427,
     428,   429,   432,   435,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   547,   548,   549,   550,   551,   552,
     553,   554,   573,   575,     0,     3,    33,    38,    41,    52,
      74,    77,    79,    80,    87,   115,   118,   130,   149,   199,
     338,   350,   359,   365,   368,   377,   379,   382,   384,   388,
     389,   391,   392,   399,   407,   408,   462,   464,   474,   513,
     514,   515,   516,   556,   557,   558,   559,   567,   568,   574,
     576,   577,   578,    19,    20,    40,   460,    20,    51,    58,
      59,    60,   375,     3,   460,   460,   115,   128,   129,   460,
     460,     3,   106,   107,   115,   133,   136,   138,   139,   257,
     331,   115,   115,    70,   106,   107,   143,   144,   145,   146,
      15,    35,    40,   449,   460,    19,    20,    39,    50,   361,
     106,   112,    38,    56,    79,   138,   366,   367,    19,    78,
      19,    74,   119,    20,   106,    19,    13,    15,    16,    17,
      18,    19,    20,    26,    27,    29,    31,    81,    87,   140,
     141,   174,   175,   189,   192,   196,   336,   344,   479,   492,
     497,   500,   501,   502,   504,   506,    19,   393,   393,   340,
      64,    69,    83,   119,   257,   311,   316,   331,   393,    41,
      74,    77,    81,    82,    84,    85,    86,    91,   125,   130,
     341,   394,   410,   393,    46,    97,   100,   102,   138,   148,
     184,   200,   201,   203,   204,   206,   207,   208,   210,   213,
     214,   216,   230,   231,   235,   237,   238,   240,   245,   249,
     250,   252,   253,   255,   256,   341,   394,   393,   258,   263,
     265,   300,   341,   394,   517,   518,   519,   393,   312,   313,
     341,   394,   393,    61,    84,   100,   123,   124,   283,   317,
     318,   319,   326,   341,   394,   417,   419,   420,   393,    60,
     138,   249,   341,   394,   569,   572,    64,    65,    66,    68,
      69,   341,   378,   381,   394,    66,   108,   341,   380,   394,
      35,    40,   340,   411,   375,     3,     3,   375,    61,   376,
       3,     3,    74,   437,   460,   460,     3,    35,    40,   340,
     414,    19,    20,    40,   461,     3,   137,   433,     3,     3,
     430,   436,    19,    84,   145,   299,   309,   310,   426,   426,
      18,    19,   352,   354,   354,     3,     3,     3,     3,     3,
       3,     3,    15,   450,     3,    22,    57,   360,    40,   340,
     362,   411,    15,    19,   336,   349,    20,    53,   338,   126,
     387,    15,    17,    18,   101,   383,   463,    19,   385,   338,
     414,   475,    15,    19,    28,   336,   343,   496,   498,   504,
      29,   336,   197,    27,   197,    15,   343,   499,   506,   336,
     336,   336,   336,   336,   336,   176,   177,   178,   179,   486,
     506,    16,    17,   336,   349,   479,   480,   484,   487,   488,
     490,   492,   493,   494,     5,    71,    72,    75,    76,   101,
     134,   180,   181,   183,   184,   185,   186,   187,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   247,   248,   259,
     260,   261,   262,   329,   330,   505,   579,     8,     9,    10,
      11,    12,    22,    23,    24,    25,    26,    27,    28,    29,
      32,   101,   340,   340,   390,   340,   411,    19,   398,    78,
     349,    34,    35,    36,    37,   349,   351,   409,    40,    87,
      88,    92,    98,   198,   395,   471,    92,   395,    92,    20,
     414,   338,   338,   340,   218,   219,   220,    20,   351,    92,
     138,   234,   122,   202,   352,   352,    67,   205,    67,   338,
     349,   203,   211,   222,   223,   215,   217,   232,   233,   232,
     236,   351,   239,   241,   246,    74,   215,    83,   251,   215,
     254,   252,   351,   338,   340,   383,   351,   349,   351,   338,
     340,   340,    74,   314,   315,   338,   340,    67,   565,   566,
      20,   349,   340,    88,   324,   325,   560,   349,   349,    67,
     201,   327,   328,   338,   338,   340,   340,   291,   354,    74,
     338,   155,   209,   242,   251,   332,   333,   334,   335,   338,
      74,   351,    67,   351,    70,   338,   338,   338,    67,    20,
     358,   338,   338,    70,    89,    90,   104,   105,   107,   412,
     413,     3,   376,     3,   349,     3,    19,     3,     3,     3,
      89,   131,   415,   416,     3,   461,     3,     3,     3,    74,
     111,   128,   202,   434,     3,    40,    74,    79,    86,    87,
      99,   108,   109,   110,   111,   113,   354,   431,   471,     3,
      19,    74,    79,    80,    87,   115,   149,   426,   426,   555,
      40,   426,    40,   426,     3,     3,    29,   339,   356,   116,
     116,     3,    18,   349,    20,    41,    42,    43,    44,    45,
      46,    47,    48,    49,   363,   364,   338,   506,   349,    54,
      55,   405,   406,   338,   157,   158,   159,   160,   161,   162,
     163,   165,   166,   167,   168,   169,   465,   466,   467,   469,
     473,   120,   121,   122,   123,   338,   386,   338,   336,   472,
     498,   498,   506,   498,   498,    14,    15,   506,   510,   511,
      26,   197,    27,   499,   499,    29,   506,   506,   506,   506,
     506,    19,    15,   342,   337,   342,    28,   482,   483,   486,
     506,     7,   342,   345,    26,    27,   340,   342,   345,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   159,   182,   188,   193,   194,    19,   115,   341,
     383,   400,   403,   404,    19,   469,   470,   349,   397,    99,
     506,   397,   397,    67,    67,    46,   338,   338,   349,   244,
     351,   352,   349,   202,    30,   353,   349,    67,   349,   338,
      67,   212,   349,   349,   351,    67,   338,    78,   338,   351,
     338,   351,   212,   242,   243,   351,   398,   351,   338,   338,
     351,   351,   351,   338,    92,   520,    19,   338,   338,   349,
     404,   338,   338,   418,   419,   338,   338,   338,   349,   338,
     338,   338,    78,   114,   154,   421,   351,   398,    20,   352,
     352,   209,   570,   571,   349,   349,   351,   349,   352,   354,
     355,   341,   342,     3,   341,   342,     3,    19,    15,   354,
      19,    19,   470,   355,    19,    20,   546,   546,     3,    19,
      77,   212,   258,   273,   291,   305,   306,   426,   546,   426,
     546,   349,   352,    15,    15,   338,   338,   341,   342,   337,
      20,   404,   338,    19,   164,   338,   340,   352,   349,   337,
     466,   468,   473,   337,   342,   337,    27,   342,   342,   342,
     337,   342,   337,   342,   506,   506,     7,   342,   342,    18,
     480,   488,    15,    18,   493,   336,   354,    27,   402,   342,
      93,   396,   351,   349,   349,   351,   338,   351,   338,   338,
     338,   349,    19,   202,   338,   349,   338,   349,   338,   338,
     338,   338,   349,   383,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   349,    84,   137,   213,   264,
     288,   290,   296,   298,   302,   303,   341,   521,   528,   531,
     338,   338,   340,   564,   341,   338,   338,   349,   101,   103,
     101,   103,   341,   338,   338,   353,   352,   301,   570,   413,
     416,     3,     3,   383,   383,    15,   383,   546,     3,   546,
       3,   202,   202,   364,   467,    19,    46,    81,   150,   151,
     152,   153,   154,   155,   156,   170,   173,   476,   477,   502,
     503,   507,   512,   338,   337,   510,    27,   506,   506,   506,
     506,   506,   342,   337,   482,   506,   483,   485,   506,   342,
     506,   116,    20,   355,   401,   403,    94,    95,    96,    97,
     338,   342,   338,   338,   338,   349,   338,   338,   338,   338,
     541,   545,   351,   266,   267,   302,   266,   351,   522,   291,
     354,   524,   525,   523,   304,   351,   338,   307,   542,   563,
     418,   338,    20,   357,   357,   357,   357,   353,   349,     3,
       3,    15,    15,    22,   336,    22,   336,   506,   506,   506,
     341,   512,   505,   579,   338,   506,   508,   509,   468,   337,
     337,   337,   337,   342,   506,   337,   342,    15,   337,    15,
     355,   349,   338,   404,   349,   349,   351,   349,   340,   383,
     340,   340,   349,   349,   340,   215,   313,   341,   562,   421,
     338,   338,   338,   338,   437,   437,   506,   511,   506,   502,
     338,   171,   340,    22,    22,    32,   342,   338,   506,   337,
       7,    28,   485,   341,   202,   338,   542,   533,   526,   533,
     529,   349,   274,   320,   321,   322,   323,   561,   338,   421,
     421,   421,   421,     3,     3,   338,   337,   338,   579,   340,
     478,   512,   495,   506,   506,    87,   140,   141,   192,   197,
     509,   337,   336,   337,     7,   337,    15,   340,   544,   341,
     354,   534,   535,   137,   266,   289,   341,   527,   341,   219,
     268,   269,   270,   272,   283,   341,   417,   530,   337,   476,
     172,     6,    15,    16,    17,   336,   341,   479,   481,   484,
     487,   489,   491,   338,   338,   336,   336,   336,   336,   338,
     482,   485,   338,   543,   289,   297,   536,   351,   349,   351,
     338,   349,   349,   349,   217,   110,   349,    88,   282,   285,
     338,   338,   341,   478,   476,   506,     7,   339,   342,   506,
     506,   506,   506,   342,   337,    60,   145,   219,   264,   266,
     268,   269,   270,   271,   272,   273,   283,   284,   287,   292,
     300,   308,   341,   417,   532,   349,   338,   349,   349,   337,
     336,   481,   476,   489,   337,   337,   337,   337,   482,   291,
     340,   349,   351,   349,   349,   349,   217,   349,   110,   349,
     274,   275,   276,   277,   278,   279,   280,   281,    88,   282,
     285,   276,   349,   293,   301,   274,   338,   506,   338,   338,
     338,   338,   337,   351,   537,   349,   349,   351,   294,   295,
     349,   349,   351,    18,   341,   538,   539,   540,   286,   338,
     338
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 644 "cf-parse.y"
    { return 0; }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 645 "cf-parse.y"
    { return 0; }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 658 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 659 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 665 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 669 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 678 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 679 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 680 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 681 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 682 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 683 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 690 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 697 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 698 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 702 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 710 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 714 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 718 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 725 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 733 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 734 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 740 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 749 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 750 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 754 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 759 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 760 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 764 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 765 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 769 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 770 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 774 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 776 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 777 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 778 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 779 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 780 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 781 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 782 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 788 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 789 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 798 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 799 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 800 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 801 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 804 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 805 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 806 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 807 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 819 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 822 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 829 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 832 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 835 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 838 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 841 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 846 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 847 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 848 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 856 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 861 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 862 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 866 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 873 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 879 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 884 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 888 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 902 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 916 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 917 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 921 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 923 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 942 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 943 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 944 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 945 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 952 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 953 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 957 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 965 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 971 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 985 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 986 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 990 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 996 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 1000 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 1012 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 1016 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 1017 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 1018 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 1019 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 1020 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1021 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1022 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 1023 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 1024 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 1025 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 1026 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 1027 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 1031 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 1033 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 1034 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 1038 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 1039 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 1040 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 1041 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 1042 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 1046 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 1055 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 1063 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 1064 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 1072 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 1080 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 1081 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 1082 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 1086 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 1087 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 1100 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 1115 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 1128 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 1142 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 1143 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 1144 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 1149 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 1153 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 1154 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 1155 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 1156 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 1157 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 1158 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 1164 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 1165 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 1166 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1171 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1175 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1176 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1197 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1215 "cf-parse.y"
    { }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1216 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1217 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1218 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1219 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 1220 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 1229 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1232 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 1235 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1238 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1242 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1246 "cf-parse.y"
    { if_show(); }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1249 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1253 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1256 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1262 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1268 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1275 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1280 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1285 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1290 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1294 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1298 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1302 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1312 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1320 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1324 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1331 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1332 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1338 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1341 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1348 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1355 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1359 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1367 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1368 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1369 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1375 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1378 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1381 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1382 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1383 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1384 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1386 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1387 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1392 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1397 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1406 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1413 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1420 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1428 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1430 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1432 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1434 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1436 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1438 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1440 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1442 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1448 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1449 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1454 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1455 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1462 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1464 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1466 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1468 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1470 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1472 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1476 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1480 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1483 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1486 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1487 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1488 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1492 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1493 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1494 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1502 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1503 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1512 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1516 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1517 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1520 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1521 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1522 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1523 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1524 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1525 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1526 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1527 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1528 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1549 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1560 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1561 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1568 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1569 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1576 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1585 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1593 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1617 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1618 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1622 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1635 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1638 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1651 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1652 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1655 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1656 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1660 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1663 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1672 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1685 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1686 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1687 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1688 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1692 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 1693 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1694 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1695 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1696 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1700 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 1703 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 1704 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1705 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1709 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1712 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1721 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1724 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1725 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1726 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1727 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1731 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1732 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 1733 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1739 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1740 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1746 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1747 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1757 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1761 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1768 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1769 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1770 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1771 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1778 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1779 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1782 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1783 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1790 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1802 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1803 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1807 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1808 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1812 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1813 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1814 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1815 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1820 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1822 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1830 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1831 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1832 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1833 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1835 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1836 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1840 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1855 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1878 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_EC:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
       case SYM_VARIABLE | T_ECLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1914 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1916 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1917 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1918 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1919 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1920 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 1922 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest);   (yyval.x)->a1.i = 1; }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1927 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1928 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1929 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1930 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1931 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1932 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1933 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1934 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1936 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1937 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1938 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1939 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1940 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1941 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1943 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1944 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1945 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1947 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1951 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1954 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1955 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1957 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1967 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1968 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1969 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1971 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1972 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1973 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1975 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1976 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1981 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 2004 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 2005 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 2006 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 2007 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 2008 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 2009 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 2013 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 2016 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 2018 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 2026 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 2033 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 2047 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 2053 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 2063 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 2072 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 2078 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 2083 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 2090 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 2095 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 2101 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 2102 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 2103 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 433:

/* Line 1806 of yacc.c  */
#line 2111 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 2112 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 2113 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 2114 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 2115 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 2121 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 2144 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 2145 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 2146 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 2156 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 2157 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 2158 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 2159 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 2160 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 2161 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 2162 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 2163 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 2164 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 2165 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 2166 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 2167 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 2168 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 2169 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 2170 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 2171 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 2172 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 2173 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 2174 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 2175 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 2176 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 2177 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 2178 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 2179 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 2180 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 2181 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 2182 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 2183 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 2184 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 2185 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 2186 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 2187 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 2188 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 2193 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 2194 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 2195 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 2196 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 2197 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 2208 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 2224 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 2225 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 2226 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 489:

/* Line 1806 of yacc.c  */
#line 2227 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 2231 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 2246 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 2255 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 2256 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 2257 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 2258 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 2259 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 2260 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 2261 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 2262 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 2263 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 2264 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 2265 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 513:

/* Line 1806 of yacc.c  */
#line 2277 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 2291 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 2292 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 2293 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 2297 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 2298 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 2307 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 2308 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 2309 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 527:

/* Line 1806 of yacc.c  */
#line 2310 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 2311 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 2312 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 2313 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 2314 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 532:

/* Line 1806 of yacc.c  */
#line 2315 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 534:

/* Line 1806 of yacc.c  */
#line 2320 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 2341 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 2342 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 2343 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 2344 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 2345 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 2346 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 2347 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 2348 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 2349 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 2350 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 2351 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 546:

/* Line 1806 of yacc.c  */
#line 2352 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 547:

/* Line 1806 of yacc.c  */
#line 2353 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 548:

/* Line 1806 of yacc.c  */
#line 2354 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 549:

/* Line 1806 of yacc.c  */
#line 2355 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 2356 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 2357 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 2358 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 553:

/* Line 1806 of yacc.c  */
#line 2359 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 2360 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 2361 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 2362 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 2364 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 2365 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 2366 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 2367 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 2368 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 563:

/* Line 1806 of yacc.c  */
#line 2369 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 2381 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 2391 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 2392 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 576:

/* Line 1806 of yacc.c  */
#line 2405 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 }
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 2414 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 }
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 2424 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 2446 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 2460 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 2465 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 2471 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 2474 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 2477 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 2482 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 2485 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 2490 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 2493 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 2500 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 2503 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 2504 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32) ;}
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 2505 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 2506 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 601:

/* Line 1806 of yacc.c  */
#line 2507 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 602:

/* Line 1806 of yacc.c  */
#line 2508 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 603:

/* Line 1806 of yacc.c  */
#line 2509 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 604:

/* Line 1806 of yacc.c  */
#line 2510 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 605:

/* Line 1806 of yacc.c  */
#line 2516 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 608:

/* Line 1806 of yacc.c  */
#line 2525 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 609:

/* Line 1806 of yacc.c  */
#line 2530 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 610:

/* Line 1806 of yacc.c  */
#line 2531 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 611:

/* Line 1806 of yacc.c  */
#line 2537 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 614:

/* Line 1806 of yacc.c  */
#line 2546 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 615:

/* Line 1806 of yacc.c  */
#line 2547 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 616:

/* Line 1806 of yacc.c  */
#line 2548 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 617:

/* Line 1806 of yacc.c  */
#line 2549 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 618:

/* Line 1806 of yacc.c  */
#line 2550 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 619:

/* Line 1806 of yacc.c  */
#line 2551 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 621:

/* Line 1806 of yacc.c  */
#line 2553 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 622:

/* Line 1806 of yacc.c  */
#line 2554 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 623:

/* Line 1806 of yacc.c  */
#line 2555 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 625:

/* Line 1806 of yacc.c  */
#line 2560 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 626:

/* Line 1806 of yacc.c  */
#line 2561 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 627:

/* Line 1806 of yacc.c  */
#line 2562 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 628:

/* Line 1806 of yacc.c  */
#line 2567 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 629:

/* Line 1806 of yacc.c  */
#line 2568 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 630:

/* Line 1806 of yacc.c  */
#line 2569 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 631:

/* Line 1806 of yacc.c  */
#line 2570 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 632:

/* Line 1806 of yacc.c  */
#line 2571 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 634:

/* Line 1806 of yacc.c  */
#line 2575 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 635:

/* Line 1806 of yacc.c  */
#line 2576 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 640:

/* Line 1806 of yacc.c  */
#line 2590 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   }
    break;

  case 642:

/* Line 1806 of yacc.c  */
#line 2606 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 645:

/* Line 1806 of yacc.c  */
#line 2615 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 646:

/* Line 1806 of yacc.c  */
#line 2616 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 648:

/* Line 1806 of yacc.c  */
#line 2620 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 649:

/* Line 1806 of yacc.c  */
#line 2629 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 650:

/* Line 1806 of yacc.c  */
#line 2637 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 2644 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 2645 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 653:

/* Line 1806 of yacc.c  */
#line 2649 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 2654 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 655:

/* Line 1806 of yacc.c  */
#line 2660 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 656:

/* Line 1806 of yacc.c  */
#line 2663 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 657:

/* Line 1806 of yacc.c  */
#line 2668 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 658:

/* Line 1806 of yacc.c  */
#line 2669 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 2670 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 660:

/* Line 1806 of yacc.c  */
#line 2671 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 661:

/* Line 1806 of yacc.c  */
#line 2672 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 662:

/* Line 1806 of yacc.c  */
#line 2676 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 724:

/* Line 1806 of yacc.c  */
#line 2684 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 725:

/* Line 1806 of yacc.c  */
#line 2684 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 727:

/* Line 1806 of yacc.c  */
#line 2684 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 736:

/* Line 1806 of yacc.c  */
#line 2687 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 737:

/* Line 1806 of yacc.c  */
#line 2687 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 738:

/* Line 1806 of yacc.c  */
#line 2687 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 739:

/* Line 1806 of yacc.c  */
#line 2687 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 740:

/* Line 1806 of yacc.c  */
#line 2688 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 741:

/* Line 1806 of yacc.c  */
#line 2688 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 742:

/* Line 1806 of yacc.c  */
#line 2689 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 743:

/* Line 1806 of yacc.c  */
#line 2690 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 744:

/* Line 1806 of yacc.c  */
#line 2691 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 745:

/* Line 1806 of yacc.c  */
#line 2692 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 746:

/* Line 1806 of yacc.c  */
#line 2693 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 747:

/* Line 1806 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 748:

/* Line 1806 of yacc.c  */
#line 2695 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 749:

/* Line 1806 of yacc.c  */
#line 2696 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 750:

/* Line 1806 of yacc.c  */
#line 2697 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 751:

/* Line 1806 of yacc.c  */
#line 2698 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 752:

/* Line 1806 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 753:

/* Line 1806 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 754:

/* Line 1806 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 755:

/* Line 1806 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 756:

/* Line 1806 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 757:

/* Line 1806 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 758:

/* Line 1806 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;



/* Line 1806 of yacc.c  */
#line 8630 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 2701 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


